
#include <windows.h>     
#include <math.h>
#include <stdio.h>


// 
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void Line_OnPaint(HWND);


int WINAPI WinMain(HINSTANCE hInstance,       // 
				   HINSTANCE hPrevInstance,
				   LPSTR     lpCmdParam, 
				   int       nCmdShow)     
{

	char cname[] = "Class";     //    
	char title[] = "Korneev V.    Graphics  to  Windows";  //  
	
	MSG msg;    //     
	
	//   
	//------------------------------------------------------------------------
	WNDCLASS wc;  //      

	wc.style          = 0; 
	wc.lpfnWndProc    = (WNDPROC)WndProc;         //  
	wc.cbClsExtra     = 0;       
	wc.cbWndExtra     = 0;       
	wc.hInstance      = hInstance;       // 
	wc.hIcon          = LoadIcon(hInstance, (LPCTSTR)IDI_APPLICATION); 
	wc.hCursor		  = LoadCursor(NULL, IDC_ARROW);  
	wc.hbrBackground  = (HBRUSH)GetStockObject(GRAY_BRUSH);   
	wc.lpszMenuName   = 0;       
	wc.lpszClassName  = cname;      

	if(!RegisterClass(&wc))  //   
		return 0;


	//  
	//------------------------------------------------------------------------
	 HWND hWnd;       //   

	 hWnd = CreateWindow(cname,
						 title,
						 WS_OVERLAPPEDWINDOW,
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 NULL,         // -     
						 NULL,          // 
						 hInstance,     // 
						 NULL);         

	if(!hWnd)
		return 0;



	//  .     ShowWindow,
    //   ,   UpdateWindows,
    //   WM_PAINT   
 	//--------------------------------------------------------------------------
	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd); 


	//    
	//-------------------------------------------------------------------------
  
	while(GetMessage(&msg,NULL,0,0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;


}

// ,  
LRESULT CALLBACK  WndProc(HWND hWnd, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
	
	switch(message)
	{
		//   
		case WM_PAINT:
			Line_OnPaint(hWnd);    //   
			break;

		//   
		case WM_DESTROY:
			PostQuitMessage(0);  //   
			break;

		default:
			return DefWindowProc(hWnd,message,wParam,lParam);
	}

	return 0;

}


//      
double xLeft, xRight, yBottom, yTop;
//       
int    nLeft, nRight, mBottom, mTop;


//  x   n
inline int xn(double x)
{
	return (int)((x - xLeft)/(xRight - xLeft)*(nRight - nLeft)) + nLeft;
}

//  y   m
inline int ym(double y)
{
	return (int)((y - yBottom)/(yTop - yBottom)*(mTop - mBottom)) + mBottom;
}


//   WM_PAINT
void Line_OnPaint(HWND hwnd)
{
	//       
	xLeft = -2; xRight =  10; yBottom =  -2; yTop =  2;
	nLeft = 100; nRight = 450; mBottom = 350; mTop = 50;

	//     x   y = sin(x)
	const int N = 50;
	double corX[N], corY[N];
	double x, y, dx = (xRight - xLeft)/(N-1);

	for(int i=0; i<N; i++)
	{
		x = xLeft + dx*i; y = sin(x);
		corX[i] = x; corY[i] = y;
	}

	HDC hdc;                  //  
	PAINTSTRUCT ps;           //       

	hdc = BeginPaint(hwnd, &ps);  //   <hdc>   <hwnd> 

	HBRUSH hbrush, hbrushOld;            // 
	HPEN hpen1, hpen2, hpen3, hpenOld;    // 

	//  <hbrush1>,  - ,  - 
	hbrush = CreateSolidBrush(RGB(0,0,200));
	//  <hbrush>    <hdc>, 
	//    <hbrushOld>
	hbrushOld = (HBRUSH)SelectObject(hdc,hbrush); 

	//  <hpen1>,  - ,  3 ,  - -
	hpen1 = CreatePen(PS_SOLID,3,RGB(255,255,0));
	//  <hpen1>    <hdc>, 
	//    <hpenOld>
	hpenOld = (HPEN)SelectObject(hdc,hpen1);    

	Rectangle(hdc,nLeft,mBottom,nRight,mTop);



	//  <hpen2>,  - ,  1 ,  - -
	hpen2 = CreatePen(PS_SOLID,1,RGB(0,255,255));
	SelectObject(hdc,hpen2);    	//  <hpen2>    <hdc>

	int nb, ne, mb, me;
	POINT  pt;
		
	//  OX
 	nb = xn(xLeft); mb = ym(0);
	MoveToEx(hdc, nb, mb, &pt);
	ne = xn(xRight); me = ym(0);
	LineTo(hdc,ne,me);

	//  OY
	nb = xn(0); mb = ym(yBottom);
	MoveToEx(hdc, nb, mb, &pt);
	ne = xn(0); me = ym(yTop);
	LineTo(hdc,ne,me);

	//   
	SetTextColor(hdc,RGB(255,255,255));
	SetBkColor(hdc,RGB(127,127,127));
	TextOut(hdc,nLeft-35, (mBottom+mTop)/2, "Y",1);
	TextOut(hdc,(nLeft+nRight)/2, mBottom+25, "X",1);

	//   
	char ss[10];
	sprintf(ss,"%6.1lf",xLeft);
	TextOut(hdc,nLeft-30,mBottom+7,ss,6);
	sprintf(ss,"%6.1lf",xRight);
	TextOut(hdc,nRight-30,mBottom+7,ss,6);
	sprintf(ss,"%6.1lf",yBottom);
	TextOut(hdc,nLeft-55,mBottom-7,ss,6);
	sprintf(ss,"%6.1lf",yTop);
	TextOut(hdc,nLeft-55,mTop+3,ss,6);

	//    

	//  <hpen3>,  - ,  2 ,  - -
	hpen3 = CreatePen(PS_SOLID,2,RGB(255,0,0));
	SelectObject(hdc,hpen3);    //  <hpen3>    <hdc>

	nb = xn(corX[0]);  mb = ym(corY[0]);
	MoveToEx(hdc, nb, mb, &pt);
	for( i=1; i<N; i++)
	{
		nb = xn(corX[i]);  mb = ym(corY[i]);
		LineTo(hdc,nb,mb);
	}

	SelectObject(hdc,hbrushOld); //   <hbrushOld>    <hdc>
	DeleteObject(hbrush);        //  <hbrush>

	SelectObject(hdc,hpenOld);   //   <hpenOld>    <hdc>
	DeleteObject(hpen1);         //  <hpen1>
	DeleteObject(hpen2);         //  <hpen2>
	DeleteObject(hpen3);         //  <hpen3>

	EndPaint(hwnd, &ps);        //   <hdc>   <hwnd>

}

