
#include <windows.h>     
#include "resource.h"     

#include <math.h>
#include <stdio.h>


//  
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void Polygon_OnDC(HWND);
void Ellipse_OnDC(HWND);


int WINAPI WinMain(HINSTANCE hInstance,       // 
				   HINSTANCE hPrevInstance,
				   LPSTR     lpCmdParam, 
				   int       nCmdShow)     
{

	char cname[] = "Class";     //    
	char title[] = "Hello   API Windows";  //  
	
	MSG msg;    //     
	
	//   
	//------------------------------------------------------------------------
	WNDCLASS wc;  //      

	wc.style          = 0; 
	wc.lpfnWndProc    = (WNDPROC)WndProc;         //  
	wc.cbClsExtra     = 0;       
	wc.cbWndExtra     = 0;       
	wc.hInstance      = hInstance;       // 
	wc.hIcon          = LoadIcon(hInstance, (LPCTSTR)IDI_APPLICATION); 
	wc.hCursor		  = LoadCursor(NULL, IDC_ARROW);  
	wc.hbrBackground  = (HBRUSH)GetStockObject(LTGRAY_BRUSH);   
	wc.lpszMenuName   = (LPCTSTR)MENU1;       
	wc.lpszClassName  = cname;      

	if(!RegisterClass(&wc))  //   
		return 0;


	//  
	//------------------------------------------------------------------------
	 HWND hWnd;       //   

	 hWnd = CreateWindow(cname,
						 title,
						 WS_OVERLAPPEDWINDOW,
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 NULL,         // -     
						 NULL,          //   
						 hInstance,     // 
						 NULL);         

	if(!hWnd)
		return 0;



	//  .     ShowWindow,
    //   ,   UpdateWindows,
    //   WM_PAINT   
 	//--------------------------------------------------------------------------
	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd); 


	//    
	//-------------------------------------------------------------------------
  
	while(GetMessage(&msg,NULL,0,0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;


}

// ,  
LRESULT CALLBACK  WndProc(HWND hWnd, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
	
	switch(message)
	{

		//   
		case WM_DESTROY:
			PostQuitMessage(0);  //   
			break;
		
		//   
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case ID_EXIT:
					PostQuitMessage(0);  //   
					break;

				case ID_CLEAN:
					InvalidateRect(hWnd, NULL, TRUE);  //  WM_PAINT
					break;

				case ID_ELLIPSE:
					Ellipse_OnDC(hWnd);
					break;

				case ID_POLYGON:
					Polygon_OnDC(hWnd);
					break;
			}
			break;

		default:
			return DefWindowProc(hWnd,message,wParam,lParam);
	}

	return 0;

}


struct POINT2 {
	double x, y;
};

//      
double xLeft, xRight, yBottom, yTop;
//       
int    nLeft, nRight, mBottom, mTop;


//  x   n
inline int xn(double x)
{
	return (int)((x - xLeft)/(xRight - xLeft)*(nRight - nLeft)) + nLeft;
}

//  y   m
inline int ym(double y)
{
	return (int)((y - yBottom)/(yTop - yBottom)*(mTop - mBottom)) + mBottom;
}

//   WM_COMMON
void Polygon_OnDC(HWND hwnd)
{

	
	RECT rc;
	GetClientRect(hwnd,&rc); //     <hwnd>

	//       
	xLeft = -10; xRight =  10; yBottom =  -6; yTop =  6;
	nLeft = rc.left; nRight = rc.right; mBottom = rc.bottom; mTop = rc.top;


	double masht; //    
	//    
	masht = (xRight-xLeft)*(mBottom-mTop)/(yTop-yBottom)/(nRight-nLeft);

	HDC hdc;            //  
	hdc = GetDC(hwnd);  //   <hdc>   <hwnd>


	HBRUSH hbrush, hbrushOld;    
	HPEN hpen1, hpen2, hpenOld;   

	hpen1 = CreatePen(PS_SOLID,1,RGB(0,255,255));
	hpenOld = (HPEN)SelectObject(hdc,hpen1);    

	int nb, ne, mb, me;

	//  OX
 	nb = xn(xLeft); mb = ym(0);
	MoveToEx(hdc, nb, mb, NULL);
	ne = xn(xRight); me = ym(0);
	LineTo(hdc,ne,me);

	//  OY
	nb = xn(0); mb = ym(yBottom);
	MoveToEx(hdc, nb, mb, NULL);
	ne = xn(0); me = ym(yTop);
	LineTo(hdc,ne,me);

	POINT2 Vt[4];
	Vt[0].x = -7; Vt[0].y = -4;
	Vt[1].x = -5; Vt[1].y = 4;
	Vt[2].x = 7;  Vt[2].y = 3;
	Vt[3].x = 3;  Vt[3].y = -2;
	
	POINT P[4];
	for(int i=0; i<4; i++)
	{
		P[i].x = xn(Vt[i].x); P[i].y = ym(Vt[i].y);
	}

	hpen2 = CreatePen(PS_SOLID,2,RGB(255,0,0));
	SelectObject(hdc,hpen2);  
	
	hbrush = CreateSolidBrush(RGB(0,200,255));
	hbrushOld = (HBRUSH)SelectObject(hdc,hbrush); 

	Polygon(hdc, P, 4);

	SelectObject(hdc,hbrushOld); 
	DeleteObject(hbrush);        

	SelectObject(hdc,hpenOld);   
	DeleteObject(hpen1);         
	DeleteObject(hpen2);         


	LOGFONT lf;
	HFONT hFont, hFontOld;

	double dx, dy, alf;
	for(int j=0; j<3; j++)
	{
		dx = Vt[j+1].x - Vt[j].x;
		dy = Vt[j+1].y - Vt[j].y;
		alf = atan2(dy*masht,dx);
		
		memset(&lf, 0, sizeof(LOGFONT)); 
		strcpy(lf.lfFaceName, "Courier New");
		lf.lfHeight = 18;
		lf.lfWeight = FW_BOLD;
		lf.lfEscapement = LONG(573*alf);
		hFont = CreateFontIndirect(&lf);
		if(j == 0)
			hFontOld = (HFONT)SelectObject(hdc, hFont);
		else
			SelectObject(hdc, hFont);

		SetBkColor(hdc,RGB(192,192,192));
		SetTextColor(hdc,RGB(255,255,255));
		TextOut(hdc,xn(Vt[j].x - 1.25*sin(alf)), ym(Vt[j].y + 1.25*cos(alf)),
					" Polygon ",9);
	}
	
	SelectObject(hdc, hFontOld); //   <hFontOld>    <hdc>
	DeleteObject(hFont);         //  <hFont> 

	ReleaseDC(hwnd, hdc);  

}


//   WM_COMMON
void Ellipse_OnDC(HWND hwnd)
{

	
	RECT rc;
	GetClientRect(hwnd,&rc); //     <hwnd>

	//       
	xLeft = -10; xRight =  10; yBottom =  -6; yTop =  6;
	nLeft = (5*rc.left + rc.right)/6; 
	nRight = (5*rc.right + rc.left)/6; 
	mBottom = (7*rc.bottom + rc.top)/8;
	mTop = (7*rc.top + rc.bottom)/8;

	HDC hdc = GetDC(hwnd);  //   <hdc>   <hwnd>

	//    
	HRGN hrgn1 = CreateRectRgn(nLeft,mTop,nRight,mBottom);

	//    
	HBRUSH hbrush1 = CreateSolidBrush(RGB(0xFF,0xFF,0xFF));
	FillRgn(hdc,hrgn1,hbrush1);

	//   
	SelectClipRgn(hdc,hrgn1);

	LOGFONT lf;
	HFONT hFont1, hFontOld;

	// ,        
	memset(&lf, 0, sizeof(LOGFONT)); 
	strcpy(lf.lfFaceName, "Arial");
	lf.lfHeight = 45;
	lf.lfWeight = FW_BOLD;
	lf.lfEscapement = 900;

	hFont1 = CreateFontIndirect(&lf);
	hFontOld = (HFONT)SelectObject(hdc, hFont1);

	TextOut(hdc,xn(-5), ym(-2),	" Ellipse ",9);


	HPEN hpen1, hpenOld;   
	hpen1 = CreatePen(PS_SOLID,1,RGB(0,255,255));
	hpenOld = (HPEN)SelectObject(hdc,hpen1);    

	int nb, ne, mb, me;

	//  OX
 	nb = xn(xLeft); mb = ym(0);
	MoveToEx(hdc, nb, mb, NULL);
	ne = xn(xRight); me = ym(0);
	LineTo(hdc,ne,me);

	//  OY
	nb = xn(0); mb = ym(yBottom);
	MoveToEx(hdc, nb, mb, NULL);
	ne = xn(0); me = ym(yTop);
	LineTo(hdc,ne,me);


	// 
	double x1 = -4, x2 = 12, y1 = 4, y2 = -4;
	

	HPEN hpen2 = CreatePen(PS_SOLID,2,RGB(255,0,0));
	SelectObject(hdc,hpen2);  
	
	HBRUSH hbrush2, hbrushOld;    
	hbrush2 = CreateSolidBrush(RGB(0,200,255));
	hbrushOld = (HBRUSH)SelectObject(hdc,hbrush2); 

	Ellipse(hdc, xn(x1), ym(y1), xn(x2), ym(y2));

	//       GDI-
	SelectObject(hdc,hbrushOld); 
	DeleteObject(hbrush1);        
	DeleteObject(hbrush2);        

	SelectObject(hdc,hpenOld);   
	DeleteObject(hpen1);         
	DeleteObject(hpen2);         

	SelectObject(hdc, hFontOld); 
	DeleteObject(hFont1);         

	DeleteObject(hrgn1);

	ReleaseDC(hwnd, hdc);  
}


