




#include <graphics.h>
#include <stdio.h>
#include <process.h>




//  ⥭ ࠦ  ࠭  ⨢ 
// ⥬ 뢮 ⮣ ࠦ  ࠭
class ScreenMemory
{

public:
	int xBlk, yBlk;

	//
	ScreenMemory(int hx0, int hy0, int x1, int y1, int x2, int y2);

	void ViewScreen();              //뢮 ࠦ  ࠭

	//뢮  ࠦ  ࠭
	void ViewScreenLock(int i0, int j0, int nx, int ny, int x, int y);

	~ScreenMemory();                //

private:
	int *xp, *yp;
	void ***saucer;
	int *hx, *hy;
	double **size;

};


//,   ࠦ  ࠭ 
//⨢   筮
//hx0, hy0 - ࠧ    ࠦ  
//x1,y1,x2,y2 - ࠧ  ࠦ  ࠭
ScreenMemory::ScreenMemory(int hx0, int hy0,
									int x1, int y1, int x2, int y2)
{
	xBlk = (x2 - x1)/hx0;
	yBlk = (y2 - y1)/hy0;
	//᫨ ࠭    뢠 ࠦ  ࠭
	//  ⥫   ࠧࠬ dxBlk, dyBlk
	int dxBlk = (x2 - x1) - xBlk*hx0;
	int dyBlk = (y2 - y1) - yBlk*hy0;
	int xflag = 0, yflag = 0;

	//室 ᫮   뢠 ࠭
	if(dxBlk>0)
	{
		xBlk++; xflag = 1;
	}

	if(dyBlk>0)
	{
		yBlk++; yflag = 1;
	}

	//뤥塞   ᨢ 蠣    ਧ⠫
	hx = new int[xBlk];
	if(hx == NULL)
	{
		closegraph();
		printf("Error of allocation of memory - hx");
		exit(1);
	}

	//뤥塞   ᨢ 蠣    ⨪
	hy = new int[yBlk];
	if(hy == NULL)
	{
		closegraph();
		printf("Error of allocation of memory - hy");
		exit(1);
	}


	//塞 ᨢ 蠣    ਧ⠫
	for(int i=0; i<xBlk; i++)
	{
		if((xflag == 1) && (i == xBlk-1))
			hx[i] = dxBlk;
		else
			hx[i] = hx0;
	}

	//塞 ᨢ 蠣    ਪ
	for(int j=0; j<yBlk; j++)
	{
		if((yflag == 1) && (j == yBlk-1))
			hy[j] = dyBlk;
		else
			hy[j] = hy0;
	}


	//뤥塞   ᨢ 㧫 祪    ਧ⠫
	xp = new int[xBlk+1];
	if(xp == NULL)
	{
		closegraph();
		printf("Error of allocation of memory - xp");
		exit(1);
	}

	//뤥塞   ᨢ 㧫 祪    ⨪
	yp = new int[yBlk+1];
	if(yp == NULL)
	{
		closegraph();
		printf("Error of allocation of memory - yp");
		exit(1);
	}



	//塞 ᨢ 㧫 祪    ਧ⠫
//	xp[0] = 0;
	xp[0] = x1;
	for( i=1; i<=xBlk; i++)
		xp[i] = xp[i-1] + hx[i-1];


	//塞 ᨢ 㧫 祪    ⨪
//	yp[0] = 0;
	yp[0] = y1;
	for( j=1; j<=yBlk; j++)
		yp[j] = yp[j-1] + hy[j-1];


	//뤥塞    ᨢ ࠧ஢ 
	size = new double* [xBlk];
	if(size == NULL)
	{
		closegraph();
		printf("Error of allocation of memory -size");
		exit(1);
	}

	for(i=0; i<xBlk; i++)
	{
		size[i] = new double[yBlk];
		if(size[i] == NULL)
		{
			closegraph();
			printf("Error of allocation of memory -size");
			exit(1);
		}
	}


	//뤥塞    ᨢ 㪠⥫ ᮢ 
	saucer = new void** [xBlk];
	if(saucer == NULL)
	{
		closegraph();
		printf("Error of allocation of memory -*sauser");
		exit(1);
	}

	for(i=0; i<xBlk; i++)
	{
		saucer[i] = new void* [yBlk];
		if(saucer[i] == NULL)
		{
			closegraph();
			printf("Error of allocation of memory -*sauser");
			exit(1);
		}
	}


	for( j=0; j<yBlk; j++)
	for(int i=0; i<xBlk; i++)
	{
		//塞 ࠧ  [i][j]
		size[i][j] = imagesize(xp[i], yp[j], xp[i+1],yp[j+1]);
		//뤥塞    [i][j]
		saucer[i][j] = new [size[i][j]];
		if(saucer[i][j] == NULL)
		{
			closegraph();
			printf("Error of allocation of memory - saucer[i][j]");
			exit(1);
		}
		//㥬  ࠦ   
		getimage(xp[i], yp[j], xp[i+1],yp[j+1], saucer[i][j]);
	}

}




//㭪 뢮 ࠦ    ࠭  筮
void ScreenMemory::ViewScreen()
{
	for(int j=0; j<yBlk; j++)
		for( int i=0; i<xBlk; i++)
			putimage(xp[i], yp[j], saucer[i][j], COPY_PUT);
}


//㭪 뢮  ࠦ    ࠭
void ScreenMemory::ViewScreenLock(int i0, int j0,
											 int nx, int ny, int x, int y)
{
	int dx = x - xp[i0], dy = y - yp[j0];
	for(int j=j0; j<j0+ny; j++)
		for( int i=i0; i<i0+nx; i++)
			putimage(dx+xp[i], dy+yp[j], saucer[i][j], COPY_PUT);
}




//, ᢮ 뤥 
ScreenMemory::~ScreenMemory()
{
//᢮    [i][j]
	for(int j=0; j<yBlk; j++)
	for( int i=0; i<xBlk; i++)
		delete saucer[i][j];



//᢮   ᨢ hx[] hy[]
	delete [] hx;
	delete [] hy;

//᢮   ᨢ xp[] yp[]
	delete [] xp;
	delete [] yp;

//᢮   ᨢ size[][]

	for(int i=0; i<xBlk; i++)
	 delete [] size[i];

	delete [] size;


//᢮   ᨢ saucer[][]

	for(i=0; i<xBlk; i++)
	 delete [] saucer[i];

	delete [] saucer;
}

