

#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <math.h>
#include <stdio.h>

// 
HINSTANCE hInstApp;
//    
HBITMAP TheBitmap[60];



// 
char const szClassName[] = "Movement";
//   
char const szWindowTitle[] = 
	"Korneev V.   Pictures from bmp-files.  Ship  and  Submarine";


// 
BOOL RegisterApp(HINSTANCE hInst);
HWND CreateApp(HINSTANCE, int);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void Move_OnCreate();
void Move_OnDestroy(HWND hwnd);
void Move_OnTimer(HWND hwnd);
void Move_OnKeydown(HWND hwnd);
void Move_OnPaint(HWND);




// 
//#pragma argsused
int PASCAL WinMain(HINSTANCE hInst,      //() 
                   HINSTANCE hPrevInstance,
                   LPSTR     lpszCmdParam,
                   int       nCmdShow)
{
	MSG msg;                         //    

	if(!RegisterApp(hInst))          // 
		return FALSE;

	if(!CreateApp(hInst,nCmdShow))   // 
		return FALSE;

	while(GetMessage(&msg,NULL,0,0))  //   
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}

//  
BOOL RegisterApp(HINSTANCE hInst)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;     //  
	wc.lpfnWndProc   = WndProc;                     //  
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;                       
	wc.hInstance     = hInst;                       // 
	wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION); // 
	wc.hCursor	 = LoadCursor(NULL, IDC_ARROW);     // 
	wc.hbrBackground = GetStockBrush(GRAY_BRUSH);   //  
	wc.lpszMenuName  = "APP_MENU";                  //  
	wc.lpszClassName = szClassName;                 // 

	return RegisterClass(&wc);           //  
}


//   
HWND CreateApp(HINSTANCE hInstance, int nCmdShow)
{

	hInstApp = hInstance;

	 HWND hwnd;   //  

	 hwnd = CreateWindow(szClassName,      //   
		 	 szWindowTitle,        //  
			 WS_OVERLAPPEDWINDOW,  //  
			 CW_USEDEFAULT,        //x -   
			 CW_USEDEFAULT,        //y -   
			 CW_USEDEFAULT,        //  
			 CW_USEDEFAULT,        //  
//			 400,
//			 330,
			 NULL,          
			 NULL,          
			 hInstance,     
			 NULL);         

	if(hwnd == NULL)
		return hwnd;

	ShowWindow(hwnd,nCmdShow);   // 
	UpdateWindow(hwnd);          //  

	return hwnd;
}

//   
LRESULT CALLBACK  WndProc(HWND hwnd, UINT msg,
			WPARAM wParam, LPARAM lParam)
{

	switch(msg)
	{
		case WM_CREATE:
			Move_OnCreate();
			break;
		case WM_PAINT:
			Move_OnPaint(hwnd);
			break;
		case WM_TIMER:
			Move_OnTimer(hwnd);
			break;
		case WM_KEYDOWN:
			Move_OnKeydown(hwnd);
			break;
		case WM_DESTROY:
			Move_OnDestroy(hwnd);
			break;
		default:
			return DefWindowProc(hwnd,msg,wParam,lParam);
	}

	return 0L;

}





//      
double xLeft, xRight, yBottom, yTop;
//        
int    nLeft, nRight, mBottom, mTop;


//  x   n
inline int xn(double x)
{
	return (int)((x - xLeft)/(xRight - xLeft)*(nRight - nLeft)) + nLeft;
}

//  y   m
inline int ym(double y)
{
	return (int)((y - yBottom)/(yTop - yBottom)*(mTop - mBottom)) + mBottom;
}


//      
//  
class Matrix2D
{

public:
	double x[3][3];

	Matrix2D();                               // 

	void rotate(double fi);                      // 
	void displa(double kx, double ky);           // 
	void transl(double tx, double ty );          // 

	// 
	friend Matrix2D operator * (const Matrix2D&, const Matrix2D&);

};

Matrix2D::Matrix2D()
{
	x[0][0] =  1; x[0][1] =  0; x[0][2] =  0;
	x[1][0] =  0; x[1][1] =  1; x[1][2] =  0;
	x[2][0] =  0; x[2][1] =  0; x[2][2] =  1;
}


void Matrix2D::rotate(double fi)
{
	double cosfi = cos(fi), sinfi = sin(fi);
	x[0][0] = cosfi; x[0][1] = -sinfi; x[0][2] = 0;
	x[1][0] = sinfi; x[1][1] =  cosfi; x[1][2] = 0;
	x[2][0] =     0; x[2][1] =      0; x[2][2] = 1;
}

void Matrix2D::displa(double kx, double ky)
{
	x[0][0] = kx; x[0][1] =  0; x[0][2] = 0;
	x[1][0] =  0; x[1][1] = ky; x[1][2] = 0;
	x[2][0] =  0; x[2][1] =  0; x[2][2] = 1;
}

void Matrix2D::transl(double tx, double ty )
{
	x[0][0] =  1; x[0][1] =  0; x[0][2] = tx;
	x[1][0] =  0; x[1][1] =  1; x[1][2] = ty;
	x[2][0] =  0; x[2][1] =  0; x[2][2] =  1;
}


Matrix2D operator * (const Matrix2D& a, const Matrix2D& b)
{
	Matrix2D c;
	double s;
	for(int i=0; i<3; i++)
		for(int j=0; j<3; j++)
		{
			s = 0;
			for(int n=0; n<3; n++)
				s += a.x[i][n]*b.x[n][j];
			c.x[i][j] = s;
		}
	return c;
}


//    
struct Point
{
	double x;
	double y;
};


//    P  
// A
Point affine( Matrix2D A,  Point P)
{
	Point Pp;
		Pp.x = A.x[0][0]*P.x + A.x[0][1]*P.y + A.x[0][2]*1;
		Pp.y = A.x[1][0]*P.x + A.x[1][1]*P.y + A.x[1][2]*1;
	return Pp;
}




//   a  b   
Point	PtP[9], PtPb[9], PtP0[9];


//""      a  b
	double tP , dtP, dtP0;

//""     
	double tPer , dtPer, dtPer0;


//       a  b
	double fiP1, fiP2, fiP1b, fiP2b, kxP, kyP;

// 6   
	Matrix2D R, R1, T, D, A, T1, T2;

//      'a'
	double xP0, yP0, xP2, yP2, xP1, yP1;

//      'b'
	double xP0b, yP0b, xP2b, yP2b, xP1b, yP1b;

//    
	int MoveStop;

//  
UINT uElapse;

//  
int iBmp, flagBmp;
//    
int flagEnd;


//    WM_CREATE
void Move_OnCreate()
{
//       
	xLeft = -10; xRight =  10; yBottom =  -7.5; yTop =  7.5;
	nLeft = 60; nRight  = 700; mTop  = 15; mBottom = 495;

//    a  b
   PtP0[0].x =  6.0; PtP0[0].y =  0.0;
   PtP0[1].x =  4.0; PtP0[1].y =  2.0;
   PtP0[2].x = -3.0; PtP0[2].y =  1.0;
   PtP0[3].x = -4.0; PtP0[3].y =  2.0;
   PtP0[4].x = -6.0; PtP0[4].y =  2.0;
   PtP0[5].x = -6.0; PtP0[5].y = -2.0;
   PtP0[6].x =  -4.0; PtP0[6].y = -2.0;
   PtP0[7].x =  -3.0; PtP0[7].y = -1.0;
   PtP0[8].x =  4.0; PtP0[8].y = -2.0;

//    a  b
   double kxyP = 0.3;
   for(int k=0; k<9; k++)
   {
		PtP0[k].x *= kxyP;	
		PtP0[k].y *= kxyP;	
   }


//   a  b
	kxP = 0.98; kyP = 0.98;

//    a  b
   dtP0 = 1.;

//    
   tPer = -20; dtPer = 0.5;

//     a  b
   tP = 0; dtP = dtP0; 

//       
	for(int n=0; n<9; n++)
   		PtP[n] = PtPb[n] = PtP0[n];
   
//  
	fiP1 = 0;
  	xP1 = 0; yP1 = 0;
	fiP1b = 0;
  	xP1b = 0; yP1b = 0;
   
   
//  
	uElapse = 250;

//  
	MoveStop = 1;

//    
//hInstApp -     
// 
//"Bitmapxx" -  
char is[3] = "";
char ssss[20] = "";
	
	for( k=0; k<50; k++)
	{
		itoa(k+10,is,10);
		strcpy(ssss,"Bitmap");
		strcat(ssss,is);
		TheBitmap[k]=LoadBitmap(hInstApp, ssss);
	}

	iBmp = 1; flagBmp = 1;
	flagEnd = 0;
}



//   WM_KEYDOWN
void Move_OnKeydown(HWND hwnd)
{
	if(MoveStop == 0)
	{
		KillTimer(hwnd, 1);
		MoveStop = 1;
	}
	else
	{
		SetTimer(hwnd, 1, uElapse, NULL);
		MoveStop = 0;
	}
}


//    WM_DESTROY
void Move_OnDestroy(HWND hwnd)
{
	KillTimer(hwnd, 1);
	for( int k=0; k<50; k++)
		DeleteObject(TheBitmap[k]);   //    
	PostQuitMessage(0);   //  
}


//  a
Point TrajP(double t)
{
	Point P;
//   P.x = 4.5*exp(-0.04*t)*sin(0.4*t);
//   P.y = -4.5*exp(-0.04*t)*cos(0.4*t);
   P.x = 15*exp(-0.06*t);
   P.y = -4*exp(-0.06*t);
   return P;
}


//  b
Point TrajPb(double t)
{
	Point P;
//   P.x = 4.5*exp(-0.04*t)*sin(0.4*t);
//   P.y = -4.5*exp(-0.04*t)*cos(0.4*t);
   P.x = -15*exp(-0.06*t);
   P.y = -4*exp(-0.06*t);
   return P;
}



//  
void Periscope(HDC hdc, int dy)
{

	HBRUSH hbrush, hbrushOld;
	HPEN hpen1, hpen2, hpenOld;

	hbrush = CreateSolidBrush(RGB(128,128,158));
	hbrushOld = (HBRUSH)SelectObject(hdc,hbrush);     //  hbrush
	hpen1 = CreatePen(PS_SOLID,4,RGB(255,255,255));
	hpenOld = (HPEN)SelectObject(hdc,hpen1);         //   hpen

	int x1,y1,x2,y2,xSt,ySt,xEn,yEn,R,x0,y0;
	R = (int)(0.3*(mBottom - mTop));
	x0 = (nRight + nLeft)/2;
	y0 = (mBottom + mTop)/2 + dy;
	x1 = x0 - R; x2 = x0 + R;
	y1 = y0 - R; y2 = y0 + R;
	xSt = x1; ySt = y0;
	xEn = x1; yEn = y0;


	Arc(hdc,x1,y1,x2,y2,xSt,ySt,xEn,yEn);
	Rectangle(hdc,x0-R/10,y2,x0+R/10,mBottom);
 	//  
	hpen2 = CreatePen(PS_SOLID,1,RGB(0,255,255));
	SelectObject(hdc,hpen2);    //   hpen

	int nb, ne, mb, me;

	nb = x1; mb = ym(0) +dy;
	MoveToEx(hdc, nb, mb, 0);
	ne = x2; me = ym(0)+dy;
	LineTo(hdc,ne,me);

	nb = xn(0); mb = y2;
	MoveToEx(hdc, nb, mb, 0);
	ne = xn(0); me = y1;
	LineTo(hdc,ne,me);

   SelectObject(hdc,hpenOld);
	DeleteObject(hpen1);           //  hpen
	DeleteObject(hpen2);           //  hpen
   SelectObject(hdc,hbrushOld);
	DeleteObject(hbrush);           //  hpen
}


//
void Crash(HDC hdc)
{


	POINT pt[12];

	pt[0].x = xn(1); pt[0].y = ym(0);
	pt[1].x = xn(3); pt[1].y = ym(2);
	pt[2].x = xn(2); pt[2].y = ym(3);
	pt[3].x = xn(0); pt[3].y = ym(1);
	pt[4].x = xn(-2); pt[4].y = ym(3);
	pt[5].x = xn(-3); pt[5].y = ym(2);
	pt[6].x = xn(-1); pt[6].y = ym(0);
	pt[7].x = xn(-3); pt[7].y = ym(-2);
	pt[8].x = xn(-2); pt[8].y = ym(-3);
	pt[9].x = xn(0); pt[9].y = ym(-1);
	pt[10].x = xn(2); pt[10].y = ym(-3);
	pt[11].x = xn(3); pt[11].y = ym(-2);

	

	HBRUSH hbrush, hbrushOld;
	HPEN hpen, hpenOld;

	hbrush = CreateSolidBrush(RGB(255,0,0));
	hbrushOld = (HBRUSH)SelectObject(hdc,hbrush);     //  hbrush
	hpen = CreatePen(PS_SOLID,1,RGB(0x70,0x70,0x70));
	hpenOld = (HPEN)SelectObject(hdc,hpen);         //   hpen

	Polygon(hdc,pt,12);

   SelectObject(hdc,hpenOld);
	DeleteObject(hpen);           //  hpen
   SelectObject(hdc,hbrushOld);
	DeleteObject(hbrush);           //  hpen


}





//     Pt   x2, y2
void Plain(HDC hdc, Point *Pt, int N, double x1,double y1,
           double x2,double y2,double fi1,double fi2,double kx,double ky)
{

//   
		T1.transl(-x1,-y1);
		R1.rotate(-fi1);
		R.rotate(fi2);
		D.displa(kx, ky);
		T.transl(x2-x1,y2-y1);
		T2.transl(x1,y1);

		A = T2*T*D*R*R1*T1;

//    
		for(int n=0; n<9; n++)
			Pt[n] = affine(A,Pt[n]);


	POINT pt[9];
	for(int i = 0; i < N; i++)
	{
      		pt[i].x = xn(Pt[i].x); pt[i].y = ym(Pt[i].y);
	}

	HBRUSH hbrush, hbrushOld;
	HPEN hpen, hpenOld;

	hbrush = CreateSolidBrush(RGB(255,0,0));
	hbrushOld = (HBRUSH)SelectObject(hdc,hbrush);     //  hbrush
	hpen = CreatePen(PS_SOLID,1,RGB(0x70,0x70,0x70));
	hpenOld = (HPEN)SelectObject(hdc,hpen);         //   hpen

	Polygon(hdc,pt,N);

   SelectObject(hdc,hpenOld);
	DeleteObject(hpen);           //  hpen
   SelectObject(hdc,hbrushOld);
	DeleteObject(hbrush);           //  hpen

}

//   a
void TracP(HDC hdc, double te, double dt)
{
	double x, y, t;

	t = 0;
	x = TrajP(t).x;
	y = TrajP(t).y;

	HPEN hpen, hpenOld;

	hpen = CreatePen(PS_SOLID,2,RGB(255,255,0));
	hpenOld = (HPEN)SelectObject(hdc,hpen);         //   hpen

	MoveToEx(hdc,xn(x),ym(y),0);
	do{
		t += dt;
		x = TrajP(t).x;
		y = TrajP(t).y;
		LineTo(hdc,xn(x),ym(y));
	}while(t < te);

   SelectObject(hdc,hpenOld);
	DeleteObject(hpen);           //  hpen

}


//   b
void TracPb(HDC hdc, double te, double dt)
{
	double x, y, t;

	t = 0;
	x = TrajPb(t).x;
	y = TrajPb(t).y;

	HPEN hpen, hpenOld;

	hpen = CreatePen(PS_SOLID,2,RGB(255,255,0));
	hpenOld = (HPEN)SelectObject(hdc,hpen);         //   hpen

	MoveToEx(hdc,xn(x),ym(y),0);
	do{
		t += dt;
		x = TrajPb(t).x;
		y = TrajPb(t).y;
		LineTo(hdc,xn(x),ym(y));
	}while(t < te);

   SelectObject(hdc,hpenOld);
	DeleteObject(hpen);           //  hpen

}


//    WM_PAINT
void Move_OnPaint(HWND hwnd)
{
	HDC hdc;
	PAINTSTRUCT ps;

	hdc = BeginPaint(hwnd, &ps);  //  

	HBRUSH hbrush, hbrushOld;
	HPEN hpen, hpenOld;

	hbrush = CreateSolidBrush(RGB(0,0,0));
	hbrushOld = (HBRUSH)SelectObject(hdc,hbrush);     //  hbrush
	hpen = CreatePen(PS_SOLID,3,RGB(255,255,255));
	hpenOld = (HPEN)SelectObject(hdc,hpen);         //   hpen

 	Rectangle(hdc,nLeft,mBottom,nRight,mTop);

   SelectObject(hdc,hpenOld);
	DeleteObject(hpen);           //  hpen
   SelectObject(hdc,hbrushOld);
	DeleteObject(hbrush);           //  hpen

	//   hdcMem     hdc
	HDC hdcMem = CreateCompatibleDC(hdc);
	//   TheBitmap    hdcMem
	HBITMAP hBitmapOld = (HBITMAP)SelectObject(hdcMem, TheBitmap[0]); 
	
	//     hdcMem    hdc
	BitBlt(hdc, nLeft, mTop, nRight-nLeft, mBottom-mTop, hdcMem, 0, 0, SRCCOPY);

	SelectObject(hdcMem, hBitmapOld); //  
	DeleteDC(hdcMem);  //    

	SetTextColor(hdc,RGB(230,230,220));
	SetBkColor(hdc,RGB(0,0,0));
   TextOut(hdc, 225,100," P r e s s   a n y   k e y ",27);

	EndPaint(hwnd, &ps);       //  

}



//    WM_TIMER
void Move_OnTimer(HWND hwnd)
{
	HDC hdcMem, hdcWin;
	HBITMAP hBitmap, hBitmapOld;
	//  
	hdcWin = GetDC(hwnd);  
	//      
	hdcMem = CreateCompatibleDC(hdcWin); 
                     
    //      -     
    //   .       
	
	// ()      
	hBitmap = CreateCompatibleBitmap(hdcWin, nRight, mBottom); 
    //   hBitmap    hdcMem          
	hBitmapOld = (HBITMAP)SelectObject(hdcMem, hBitmap); 
                
	//  TheBitmap      hdcMem1
	//       hdcMem.    
	//      
	//  
	
	//    hdcMem1
	//      hdcMem
	HDC hdcMem1 = CreateCompatibleDC(hdcMem); 
    //   TheBitmap    hdcMem1
	int numberBmp;
	if(flagEnd == 1)
		numberBmp = 30;
	else 
		numberBmp = iBmp;
	SelectObject(hdcMem1, TheBitmap[numberBmp]); 
	
	if(flagBmp == 1)
	{
		iBmp++;
		if(iBmp>49)
		{
			flagBmp = 2;
			iBmp--;
		}
	}

	if(flagBmp == 2)
	{
		iBmp--;
		if(iBmp<0)
		{
			flagBmp = 1;
			iBmp++;
		}
	}

	//  TheBitmap   
	//  hdcMem1      hdcMem 
	BitBlt(hdcMem, nLeft,mTop, nRight-nLeft, mBottom-mTop, hdcMem1, 0,0, SRCCOPY);




if(tPer>6)
{
		if(flagEnd == 0)
		{

	tP += dtP;
//		dtP *= 0.998;
		xP2 = TrajP(tP).x;
		yP2 = TrajP(tP).y;
		xP2b = TrajPb(tP).x;
		yP2b = TrajPb(tP).y;

	if(fabs(xP2)+fabs(yP2)<1)
		flagEnd = 1;

      fiP2 =atan2l(yP2-yP1,xP2-xP1);
      fiP2b =atan2l(yP2b-yP1b,xP2b-xP1b);

	TracP(hdcMem, tP, dtP);
	Plain(hdcMem,PtP,9,xP1,yP1,xP2,yP2,fiP1,fiP2,kxP,kyP);

	xP1 = xP2; yP1 = yP2; fiP1 = fiP2;

	TracPb(hdcMem, tP, dtP);
	Plain(hdcMem,PtPb,9,xP1b,yP1b,xP2b,yP2b,fiP1b,fiP2b,kxP,kyP);

	xP1b = xP2b; yP1b = yP2b; fiP1b = fiP2b;

	Periscope(hdcMem, 0);
		}
		else
		{
	Crash(hdcMem);
	Periscope(hdcMem,0);
		}
}
else
{
	Periscope(hdcMem, ym(tPer));
	tPer += dtPer;
	
}
		//     
	BitBlt(hdcWin, nLeft,mTop, nRight-nLeft, mBottom-mTop, hdcMem, nLeft,mTop, SRCCOPY);

	SelectObject(hdcMem, hBitmapOld); //  
	DeleteObject(hBitmap);           //  
	DeleteDC(hdcMem);                //    
	DeleteDC(hdcMem1);               //    
	ReleaseDC(hwnd,hdcWin);          //  
}






