//       
//     

//     
//      

//  ,  ,  ,  

#define STRICT
#include <windows.h>
#include <math.h>
#include <stdio.h>

//   
const char Cname[] = "SurfClass";      
//  
const char Title[] = "Korneev V.        "
          " Spherical Surface Element    rotation  by  mouse  and  keyboard (arrows) ";  

//    
struct ANGLS {
	double fi, teta;
};

static ANGLS angl,anglOld;

//     
struct POINT3 {
	double x, y, z;
};

static POINT3 Point[8];

//    
struct TDATA {

	BOOL ButtonDown;
	BOOL Drawing;
};

static TDATA Dat;

// 
struct CORD {
	int x, y;
};

static CORD corOld;

//    
struct POINT2 {
	int x, y;
};



// 
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void SurfCreate();
void SurfDestroy();
void SurfPaint(HWND);
void DrawBox(HDC, ANGLS);
void PointCorns();
void SurfDC(HWND);
void SurfLButtonDown(int,int);
void SurfMouseMove(int,int);
void SurfLButtonUp();
void PointCorns();
void Picture(HDC);
void Axes(HDC);
inline double Xe(double,double);
inline double Ye(double,double,double);
inline int xn(double);
inline int ym(double);
void Sphere(HDC);



int WINAPI WinMain(HINSTANCE hInstance,       // 
				   HINSTANCE hPrevInstance,
				   LPSTR     lpCmdParam, 
				   int       nCmdShow)     
{

	
	MSG msg;    //     
	
	//   
	//------------------------------------------------------------------------
	WNDCLASS wc;  //      

	wc.style          = 0; 
	wc.lpfnWndProc    = (WNDPROC)WndProc;         //  
	wc.cbClsExtra     = 0;       
	wc.cbWndExtra     = 0;       
	wc.hInstance      = hInstance;       // 
	wc.hIcon          = LoadIcon(hInstance, (LPCTSTR)IDI_APPLICATION); 
	wc.hCursor		  = LoadCursor(NULL, IDC_ARROW);  
	wc.hbrBackground  = (HBRUSH)GetStockObject(GRAY_BRUSH);   
	wc.lpszMenuName   = 0;       
	wc.lpszClassName  = Cname;      

	if(!RegisterClass(&wc))  //   
		return 0;


	//  
	//------------------------------------------------------------------------
	 HWND hWnd;       //   

	 hWnd = CreateWindow(Cname,
						 Title,
						 WS_OVERLAPPEDWINDOW,
                         100, //x -  .. 
                         50,  //y -  .. 
                         650, // 
                         500, // 
//						 CW_USEDEFAULT, 
//						 CW_USEDEFAULT, 
//						 CW_USEDEFAULT, 
//						 CW_USEDEFAULT, 
						 NULL,         // -     
						 NULL,          // 
						 hInstance,     // 
						 NULL);         

	if(!hWnd)
		return 0;


	//  .     ShowWindow,
    //   ,   UpdateWindows,
    //   WM_PAINT   
 	//--------------------------------------------------------------------------
	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd); 


	//    
	//-------------------------------------------------------------------------
  
	while(GetMessage(&msg,NULL,0,0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;

}



//   
LRESULT CALLBACK  WndProc(HWND hwnd, UINT msg,
						WPARAM wParam, LPARAM lParam)
{
	int x,y;
	switch(msg)
	{
		case WM_CREATE:
			SurfCreate();
			break;

		case WM_PAINT:
			SurfPaint(hwnd);
			break;
		case WM_LBUTTONDOWN:
				x = LOWORD(lParam);
				y = HIWORD(lParam);
				SurfLButtonDown(x,y);
			break;

		case WM_LBUTTONUP:
				SurfLButtonUp();
			break;


		case WM_MOUSEMOVE:
				x = LOWORD(lParam);
				y = HIWORD(lParam);
				SurfMouseMove(x,y);
				SurfDC(hwnd);
			break;

		case WM_DESTROY:
			SurfDestroy();
			break;

		case WM_KEYDOWN:
			switch(wParam)
			{
				case VK_LEFT:
					angl.fi += 10;
					SurfDC(hwnd);
					break;

				case VK_RIGHT:
					angl.fi -= 10;
					SurfDC(hwnd);
					break;

				case VK_UP:
					angl.teta += 10;
					SurfDC(hwnd);
					break;

				case VK_DOWN:
					angl.teta -= 10;
					SurfDC(hwnd);
					break;
			}
			break;



		default:
			return DefWindowProc(hwnd,msg,wParam,lParam);
	}

	return 0L;
}



//        
double xe1, xe2, ye1, ye2;
int    ne1, ne2, me1, me2;

//    -  
  double xmax, ymax, zmax;

// 
double sf,cf,st,ct;


//   
void SurfCreate()
{
	//        
	xe1 = -4.5;  xe2 =   4.5; ye1 =  -4.5; ye2 =  4.5;
	ne1 = 175; ne2 = 475; me1 = 375; me2 = 75;

	//    -  
	xmax=3., ymax=3., zmax=3.;


	//    -  
	angl.fi = 30; angl.teta = 60;

	//     
	PointCorns();

}


//   
void SurfDestroy()
{
	PostQuitMessage(0);   // 
}





//      WM_PAINT
void SurfPaint(HWND hwnd)
{
	PAINTSTRUCT ps;

	//  
	HDC hdcWin = BeginPaint(hwnd, &ps);

	//  
	Picture(hdcWin);

	//  
	EndPaint(hwnd, &ps);
}

//      WM_MOUSEMOVE
void SurfDC(HWND hwnd)
{

	//  
	HDC hdcWin = GetDC(hwnd);

	//  
	Picture(hdcWin);

	//  
	ReleaseDC(hwnd, hdcWin);

}



//  
void Picture(HDC hdcWin)
{
	//      
	HDC hdcMem = CreateCompatibleDC(hdcWin); 
	//      
	HBITMAP hBitmap = CreateCompatibleBitmap(hdcWin, ne2, me1); 
    //     
    HBITMAP hBitmapOld = (HBITMAP)SelectObject(hdcMem, hBitmap); 

	//      
	HRGN hrgn1 = CreateRectRgn(ne1,me2-30,ne2,me2-2);

	//    
	HBRUSH hBrush0 = CreateSolidBrush(RGB(0xA6,0xCA,0xF0));
    FillRgn(hdcMem,hrgn1,hBrush0);
	//    
	HBRUSH hBrush1 = CreateSolidBrush(RGB(0xFF,0xFF,0xC0));
	FrameRgn(hdcMem,hrgn1,hBrush1,2,2);

	//      hrgn1
	char ss[10];
	SetBkColor(hdcMem,RGB(0xA6,0xCA,0xF0));
	SetTextColor(hdcMem,RGB(0,0,0x80));
	sprintf(ss,"fi = %4.0lf",angl.fi);
	TextOut(hdcMem,(ne1+ne2)/2-80,me2-25,ss,9);
	sprintf(ss,"teta = %4.0lf",angl.teta);
	TextOut(hdcMem,(ne1+ne2)/2+20,me2-25,ss,11);

	//  hrgn1
	DeleteObject(hrgn1); 

	//       
	HRGN hrgn2 = CreateRectRgn(ne1,me2,ne2,me1);

	//    
	HBRUSH hBrush2 = CreateSolidBrush(RGB(0xC0,0xC0,0xC0));
	FillRgn(hdcMem,hrgn2,hBrush2);

	//   
	SelectClipRgn(hdcMem,hrgn2);

	//       
	sf=sin(3.14159*angl.fi/180);
	cf=cos(3.14159*angl.fi/180);
	st=sin(3.14159*angl.teta/180);
	ct=cos(3.14159*angl.teta/180);

	//  
	Axes(hdcMem);


	Sphere(hdcMem);


	//  
	DrawBox(hdcMem, angl);
	
	//     
	BitBlt(hdcWin,ne1,me2-30,ne2,me1,hdcMem,ne1,me2-30,SRCCOPY); 
   

	//   
	DeleteObject(hBrush0);
	DeleteObject(hBrush1);
	DeleteObject(hBrush2);
	DeleteObject(hrgn2);

	SelectObject(hdcMem, hBitmapOld); //  
	DeleteObject(hBitmap); //  
	DeleteDC(hdcMem);  //    
}



// 2D -
void arrowVector(HDC hdc, int x1, int y1, int x2, int y2, COLORREF rgb)
{

	int x3, y3, x4, y4, x0, y0;
	x0 = int(0.85*(x2 - x1)) + x1;
	y0 = int(0.85*(y2 - y1)) + y1;
	x3 = -int(0.07*(y2 - y1)) + x0;
	y3 = int(0.07*(x2 - x1)) + y0;
	x4 = int(0.07*(y2 - y1)) + x0;
	y4 = -int(0.07*(x2 - x1)) + y0;

	HPEN hPen = CreatePen(PS_SOLID,2,rgb);
	HPEN hPenOld = (HPEN)SelectObject(hdc,hPen);
	
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);
	MoveToEx(hdc,x3,y3,0);
	LineTo(hdc,x2,y2);
	LineTo(hdc,x4,y4);

	SelectObject(hdc,hPenOld);
	DeleteObject(hPen);
}



//   
POINT3 SphereP(double u, double v)
{
	POINT3 p;
    p.x = 3*cos(3.14159/180*u)*cos(3.14159/180*v);
    p.y = 3*sin(3.14159/180*u)*cos(3.14159/180*v);
    p.z = 3*sin(3.14159/180*v);
	return p;
}

//     (u,v)    
POINT2 ParamPixel(double u, double v)
{
	POINT2 p;
	double xt,yt,zt,xe,ye;

	xt = SphereP(u,v).x;
	yt = SphereP(u,v).y;
	zt = SphereP(u,v).z;

	xe = Xe(xt,yt);
	ye = Ye(xt,yt,zt);

	p.x = xn(xe);
	p.y = ym(ye);

	return p;
}


//   
void Sphere(HDC hdc)
{

	int x1,y1;

	HPEN hPen = CreatePen(PS_SOLID,1,RGB(255,255,0));
	HPEN hPenOld = (HPEN)SelectObject(hdc,hPen);

	POINT2 p;

	//    (u,v)   

	//" "
	int Ns=10, Nsp = 10;
	double u,v,du,dv,ub,ue,vb,ve;
	ub = 0; ue = 90; vb = 15; ve = 75;
	du = (ue - ub)/(Ns-1); dv = (ve - vb)/(Nsp-1);

   	for (int i=0; i<Nsp; i++)
   	{
    	v = vb + dv*i;
		u = ub;
		
		p = ParamPixel(u,v);
		x1 = p.x; y1 = p.y;
        MoveToEx(hdc,x1,y1,0);

		for(int j=1; j<Ns; j++)
		{
			u = ub + du*j;

  			p = ParamPixel(u,v);
			x1 = p.x; y1 = p.y;
			LineTo(hdc,x1,y1);
		}
    }


	//" "
	int Ms=10, Msp = 10;
	du = (ue - ub)/(Ms-1); dv = (ve - vb)/(Msp-1);

	for ( i=0; i<Msp; i++)
   	{
    	u =  ub + du*i;
		v = vb;

		p = ParamPixel(u,v);
		x1 = p.x; y1 = p.y;
       	MoveToEx(hdc,x1,y1,0);

		for(int j=1; j<Ms; j++)
		{
			v = vb + dv*j;

			p = ParamPixel(u,v);
			x1 = p.x; y1 = p.y;
			LineTo(hdc,x1,y1);
		}
	}


	//        
	//  
	//  
	double xt0, yt0, zt0, xt1, yt1, zt1, xt2, yt2, zt2, xt3, yt3, zt3, xe, ye;
	double rux, ruy, ruz, rvx, rvy, rvz, Nx, Ny, Nz;
	int x2, y2, x3, y3, x4, y4;

	double u0, v0;
	u0 = 40; v0 = 41;

	u = u0; v = v0;
	xt0 = SphereP(u,v).x;
	yt0 = SphereP(u,v).y;
	zt0 = SphereP(u,v).z;

	u = u0; v = v0 + dv;
	xt1 = SphereP(u,v).x;
	yt1 = SphereP(u,v).y;
	zt1 = SphereP(u,v).z;
					
	//  rv
	rvx = 5*(xt1-xt0);
	rvy = 5*(yt1-yt0);
	rvz = 5*(zt1-zt0);

	u = u0 + du; v = v0;
	xt2 = SphereP(u,v).x;
	yt2 = SphereP(u,v).y;
	zt2 = SphereP(u,v).z;

	//  ru
	rux = 5*(xt2-xt0);
	ruy = 5*(yt2-yt0);
	ruz = 5*(zt2-zt0);


	HPEN hPen1 = CreatePen(PS_SOLID,1,RGB(255,255,255));
	SelectObject(hdc,hPen1);

	//  
	double xp, yp, zp;
	double tu, tv, dtu, dtv;
	int Nu = 15, Nv = 15;
	dtu = 1.3/(Nu-1); dtv = 1.3/(Nv-1);
	for(int  iu=0; iu<Nu; iu++)
	{
		tu = -0.65 + dtu*iu; tv = -0.65;
			xp = rux*tu + rvx*tv + xt0;
			yp = ruy*tu + rvy*tv + yt0;
			zp = ruz*tu + rvz*tv + zt0;

			xe = Xe(xp,yp);
			ye = Ye(xp,yp,zp);

			x1 = xn(xe);
			y1 = ym(ye);

	       	MoveToEx(hdc,x1,y1,0);

			tv = 0.65;

			xp = rux*tu + rvx*tv + xt0;
			yp = ruy*tu + rvy*tv + yt0;
			zp = ruz*tu + rvz*tv + zt0;

			xe = Xe(xp,yp);
			ye = Ye(xp,yp,zp);

			x1 = xn(xe);
			y1 = ym(ye);
			
			LineTo(hdc,x1,y1);
	}
	
	for(int  iv=0; iv<Nv; iv++)
	{
		tv = -0.65 + dtu*iv; tu = -0.65;
			xp = rux*tu + rvx*tv + xt0;
			yp = ruy*tu + rvy*tv + yt0;
			zp = ruz*tu + rvz*tv + zt0;

			xe = Xe(xp,yp);
			ye = Ye(xp,yp,zp);

			x1 = xn(xe);
			y1 = ym(ye);

	       	MoveToEx(hdc,x1,y1,0);

			tu = 0.65;

			xp = rux*tu + rvx*tv + xt0;
			yp = ruy*tu + rvy*tv + yt0;
			zp = ruz*tu + rvz*tv + zt0;

			xe = Xe(xp,yp);
			ye = Ye(xp,yp,zp);

			x1 = xn(xe);
			y1 = ym(ye);
			
			LineTo(hdc,x1,y1);
	}




	//  
	xe = Xe(xt0,yt0);
	ye = Ye(xt0,yt0,zt0);

	x1 = xn(xe);
	y1 = ym(ye);

	xt1 = xt0 + rvx;
	yt1 = yt0 + rvy;
	zt1 = zt0 + rvz;

	xe = Xe(xt1,yt1);
	ye = Ye(xt1,yt1,zt1);

	x2 = xn(xe);
	y2 = ym(ye);

	arrowVector(hdc, x1, y1, x2, y2, RGB(255,0,0));
	TextOut(hdc,x2-2, y2-20, "rv",2);
	
	xt2 = xt0 + rux;
	yt2 = yt0 + ruy;
	zt2 = zt0 + ruz;

	xe = Xe(xt2,yt2);
	ye = Ye(xt2,yt2,zt2);

	x3 = xn(xe);
	y3 = ym(ye);

	arrowVector(hdc, x1, y1, x3, y3, RGB(255,0,0));
	TextOut(hdc,x3+5, y3-8, "ru",2);

	//     
	Nx =    ruy*rvz - ruz*rvy;
	Ny =  - rux*rvz + ruz*rvx;
	Nz =    rux*rvy - ruy*rvx;

	xt3 = xt0 + Nx;
	yt3 = yt0 + Ny;
	zt3 = zt0 + Nz;

	xe = Xe(xt3,yt3);
	ye = Ye(xt3,yt3,zt3);

	x4 = xn(xe);
	y4 = ym(ye);

	arrowVector(hdc, x1, y1, x4, y4, RGB(0,0,255));
	TextOut(hdc,x4+2, y4-8, "N",1);



	
	

	//    
	SelectObject(hdc,hPenOld);
	//   
	DeleteObject(hPen);
	DeleteObject(hPen1);
	
}




//  
void Axes(HDC hdc)
{
	//    
	HPEN hPen = CreatePen(PS_SOLID,1,RGB(0,255,255));
	HPEN hPenOld = (HPEN)SelectObject(hdc,hPen);

	//      
	double xe, ye;
	// 
	int x1,y1,x2,y2;

	//  Ox
	xe=Xe(-xmax/3,0);
	ye=Ye(-xmax/3,0,0);
	x1=xn(xe);
	y1=ym(ye);             
	xe=Xe(1.5*xmax,0);
	ye=Ye(1.5*xmax,0,0);
	x2=xn(xe);
	y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

	//     
	SetBkColor(hdc,RGB(0xC0,0xC0,0xC0));
	SetTextColor(hdc,RGB(120,120,120));
	TextOut(hdc,x2, y2, "X",1);
	
	//  Oy
	xe=Xe(0,-ymax/3);
	ye=Ye(0,-ymax/3,0);
	x1=xn(xe);
	y1=ym(ye);
	xe=Xe(0,1.5*ymax);
	ye=Ye(0,1.5*ymax,0);
	x2=xn(xe);
	y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

	TextOut(hdc,x2, y2, "Y",1);

	//  Oz
	xe=Xe(0,0);
	ye=Ye(0,0,-zmax/3);
	x1=xn(xe);
	y1=ym(ye);
	xe=Xe(0,0);
	ye=Ye(0,0,1.5*zmax);
	x2=xn(xe);
	y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

	TextOut(hdc,x2, y2, "Z",1);

	//    
	SelectObject(hdc,hPenOld);
	//   
	DeleteObject(hPen);

}

//  -    
void	PointCorns()
{
	Point[0].x =  xmax; Point[0].y =  ymax; Point[0].z = -zmax;
	Point[1].x = -xmax; Point[1].y =  ymax; Point[1].z = -zmax;
	Point[2].x = -xmax; Point[2].y = -ymax; Point[2].z = -zmax;
	Point[3].x =  xmax; Point[3].y = -ymax; Point[3].z = -zmax;
	Point[4].x =  xmax; Point[4].y =  ymax; Point[4].z = zmax;
	Point[5].x = -xmax; Point[5].y =  ymax; Point[5].z = zmax;
	Point[6].x = -xmax; Point[6].y = -ymax; Point[6].z = zmax;
	Point[7].x =  xmax; Point[7].y = -ymax; Point[7].z = zmax;
}


//  
void DrawBox(HDC hdc, ANGLS an)
{

	HPEN hPen = CreatePen(PS_SOLID,1,RGB(160,160,160));
	HPEN hPenOld = (HPEN)SelectObject(hdc,hPen);

   double xe, ye;
	int x1,y1,x2,y2;
	double xt1,yt1,zt1,xt2,yt2,zt2;
   int j;

	for(int i=0; i<4; i++)
	{
		j = i + 1;
		if(j==4)
			j = 0;
		xt1 = Point[i].x; yt1 = Point[i].y; zt1 = Point[i].z;
		xt2 = Point[j].x; yt2 = Point[j].y; zt2 = Point[j].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	for( i=4; i<8; i++)
	{
		j = i + 1;
		if(j==8)
			j = 4;
		xt1 = Point[i].x; yt1 = Point[i].y; zt1 = Point[i].z;
		xt2 = Point[j].x; yt2 = Point[j].y; zt2 = Point[j].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	for( i=0; i<4; i++)
	{
		xt1 =   Point[i].x; yt1 =   Point[i].y; zt1 =   Point[i].z;
		xt2 = Point[i+4].x; yt2 = Point[i+4].y; zt2 = Point[i+4].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	for( i=0; i<2; i++)
	{
		xt1 =   Point[i].x; yt1 =   Point[i].y; zt1 =   Point[i].z;
		xt2 = Point[i+2].x; yt2 = Point[i+2].y; zt2 = Point[i+2].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	//    
	SelectObject(hdc,hPenOld);
	DeleteObject(hPen);

}





//       
inline double Xe(double x,double y)
{
  return -sf*x+cf*y;
}

//       
inline double Ye(double x,double y,double z)
{
  return -ct*cf*x-ct*sf*y+st*z;
}


//     
//   x    n
inline int xn(double x)
{
	return (int)((x - xe1)/(xe2 - xe1)*(ne2 - ne1)) + ne1;
}

//   y    m
inline int ym(double y)
{
	return (int)((y - ye1)/(ye2 - ye1)*(me2 - me1)) + me1;
}






//     
void SurfLButtonDown( int x, int y)
{
	Dat.ButtonDown = TRUE;
	Dat.Drawing = FALSE;

	anglOld.fi = angl.fi;
	anglOld.teta = angl.teta;
	corOld.x = x;
	corOld.y = y;

}



//       
void SurfMouseMove(int x, int y)
{
	if(Dat.ButtonDown)
	{
		Dat.Drawing = TRUE;

		angl.fi += corOld.x-x;
		angl.teta += corOld.y-y;

		corOld.x = x; corOld.y = y;

		anglOld.fi   = angl.fi;
		anglOld.teta   = angl.teta;
	}
}



//       
void SurfLButtonUp()
{
	if(Dat.ButtonDown && Dat.Drawing)
	{
		Dat.Drawing = FALSE;
	}
	Dat.ButtonDown = FALSE;
}





