//       
//     

//     
//      

//  B- 

#define STRICT
#include <windows.h>
#include <math.h>
#include <stdio.h>

//   
const char Cname[] = "SurfClass";      
//  
const char Title[] = "Korneev V.        "
          " Composite B-spline Surface    rotation  by  mouse  and  keyboard (arrows) ";  

//    
struct ANGLS {
	double fi, teta;
};

static ANGLS angl,anglOld;

//     
struct POINT3 {
	double x, y, z;
};

static POINT3 Point[8];

//    
struct TDATA {

	BOOL ButtonDown;
	BOOL Drawing;
};

static TDATA Dat;

// 
struct CORD {
	int x, y;
};

static CORD corOld;

//    
struct POINT2 {
	int x, y;
};



// 
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void SurfCreate();
void SurfDestroy();
void SurfPaint(HWND);
void DrawBox(HDC, ANGLS);
void PointCorns();
void SurfDC(HWND);
void SurfLButtonDown(int,int);
void SurfMouseMove(int,int);
void SurfLButtonUp();
void PointCorns();
void Picture(HDC);
void Axes(HDC);
inline double Xe(double,double);
inline double Ye(double,double,double);
inline int xn(double);
inline int ym(double);
void SplineSurf(HDC);



int WINAPI WinMain(HINSTANCE hInstance,       // 
				   HINSTANCE hPrevInstance,
				   LPSTR     lpCmdParam, 
				   int       nCmdShow)     
{

	
	MSG msg;    //     
	
	//   
	//------------------------------------------------------------------------
	WNDCLASS wc;  //      

	wc.style          = 0; 
	wc.lpfnWndProc    = (WNDPROC)WndProc;         //  
	wc.cbClsExtra     = 0;       
	wc.cbWndExtra     = 0;       
	wc.hInstance      = hInstance;       // 
	wc.hIcon          = LoadIcon(hInstance, (LPCTSTR)IDI_APPLICATION); 
	wc.hCursor		  = LoadCursor(NULL, IDC_ARROW);  
	wc.hbrBackground  = (HBRUSH)GetStockObject(GRAY_BRUSH);   
	wc.lpszMenuName   = 0;       
	wc.lpszClassName  = Cname;      

	if(!RegisterClass(&wc))  //   
		return 0;


	//  
	//------------------------------------------------------------------------
	 HWND hWnd;       //   

	 hWnd = CreateWindow(Cname,
						 Title,
						 WS_OVERLAPPEDWINDOW,
                         100, //x -  .. 
                         50,  //y -  .. 
                         650, // 
                         500, // 
//						 CW_USEDEFAULT, 
//						 CW_USEDEFAULT, 
//						 CW_USEDEFAULT, 
//						 CW_USEDEFAULT, 
						 NULL,         // -     
						 NULL,          // 
						 hInstance,     // 
						 NULL);         

	if(!hWnd)
		return 0;


	//  .     ShowWindow,
    //   ,   UpdateWindows,
    //   WM_PAINT   
 	//--------------------------------------------------------------------------
	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd); 


	//    
	//-------------------------------------------------------------------------
  
	while(GetMessage(&msg,NULL,0,0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;

}



//   
LRESULT CALLBACK  WndProc(HWND hwnd, UINT msg,
						WPARAM wParam, LPARAM lParam)
{
	int x,y;
	switch(msg)
	{
		case WM_CREATE:
			SurfCreate();
			break;

		case WM_PAINT:
			SurfPaint(hwnd);
			break;
		case WM_LBUTTONDOWN:
				x = LOWORD(lParam);
				y = HIWORD(lParam);
				SurfLButtonDown(x,y);
			break;

		case WM_LBUTTONUP:
				SurfLButtonUp();
			break;


		case WM_MOUSEMOVE:
				x = LOWORD(lParam);
				y = HIWORD(lParam);
				SurfMouseMove(x,y);
				SurfDC(hwnd);
			break;

		case WM_DESTROY:
			SurfDestroy();
			break;

		case WM_KEYDOWN:
			switch(wParam)
			{
				case VK_LEFT:
					angl.fi += 10;
					SurfDC(hwnd);
					break;

				case VK_RIGHT:
					angl.fi -= 10;
					SurfDC(hwnd);
					break;

				case VK_UP:
					angl.teta += 10;
					SurfDC(hwnd);
					break;

				case VK_DOWN:
					angl.teta -= 10;
					SurfDC(hwnd);
					break;
			}
			break;



		default:
			return DefWindowProc(hwnd,msg,wParam,lParam);
	}

	return 0L;
}



//        
double xe1, xe2, ye1, ye2;
int    ne1, ne2, me1, me2;

//    -  
  double xmax, ymax, zmax;

// 
double sf,cf,st,ct;




// 
//  B-  Nelm x Melm
const int Nelm = 2, Melm = 12;  
//   Np x Mp
const int Np = Nelm + 3, Mp = Melm + 3;

//  
POINT3 Vp[Np][Mp];


// 16-  
//  B- 
POINT3 Ve[4][4];


//,     
const int Ntext = 100;
// 
double ut[Ntext], vt[Ntext];




//   
void SurfCreate()
{
	//        
	xe1 = -4.5;  xe2 =   4.5; ye1 =  -4.5; ye2 =  4.5;
	ne1 = 175; ne2 = 475; me1 = 375; me2 = 75;

	//    -  
	xmax=3., ymax=3., zmax=3.;


	//    -  
	angl.fi = 30; angl.teta = 60;

	//     
	PointCorns();

	// 16     
	double phi, tet, dphi, dtet;
	double phib, phie, tetb, tete;
	int Nphi=Mp, Ntet = Np;
	phib = 0; phie = 360; tetb = 30; tete = 110;
	dphi = (phie - phib)/(Nphi-3); dtet = (tete - tetb)/(Ntet-1);

	//        
	for(int m = 1; m < Nphi-1; m++)
	{
   		phi = phib + dphi*(m-1);
		for(int n = 0; n < Ntet; n++)
		{
      		tet = tetb + dtet*n;
	      	Vp[n][m].x = 4*sin(3.14159/180*tet)*cos(3.14159/180*phi);
		  	Vp[n][m].y = 4*sin(3.14159/180*tet)*sin(3.14159/180*phi);
			Vp[n][m].z = 4*cos(3.14159/180*tet);
		}
	}
/*
	//     - 
	for(int n=1; n<=Np-2; n++)
	{
		Vp[n][0].x = 2*Vp[n][1].x - Vp[n][2].x;
		Vp[n][0].y = 2*Vp[n][1].y - Vp[n][2].y;
		Vp[n][0].z = 2*Vp[n][1].z - Vp[n][2].z;

		Vp[n][Mp-1].x = 2*Vp[n][Mp-2].x - Vp[n][Mp-3].x;
		Vp[n][Mp-1].y = 2*Vp[n][Mp-2].y - Vp[n][Mp-3].y;
		Vp[n][Mp-1].z = 2*Vp[n][Mp-2].z - Vp[n][Mp-3].z;
	}
*/
	//      
	for( int n=1; n<=Np-2; n++)
	{
		Vp[n][0].x = Vp[n][Mp-3].x;
		Vp[n][0].y = Vp[n][Mp-3].y;
		Vp[n][0].z = Vp[n][Mp-3].z;

		Vp[n][Mp-1].x = Vp[n][2].x;
		Vp[n][Mp-1].y = Vp[n][2].y;
		Vp[n][Mp-1].z = Vp[n][2].z;
	}

	
	
	//     - 
	for(m=0; m<=Mp-1; m++)
	{
		Vp[0][m].x = 2*Vp[1][m].x - Vp[2][m].x;
		Vp[0][m].y = 2*Vp[1][m].y - Vp[2][m].y;
		Vp[0][m].z = 2*Vp[1][m].z - Vp[2][m].z;

		Vp[Np-1][m].x = 2*Vp[Np-2][m].x - Vp[Np-3][m].x;
		Vp[Np-1][m].y = 2*Vp[Np-2][m].y - Vp[Np-3][m].y;
		Vp[Np-1][m].z = 2*Vp[Np-2][m].z - Vp[Np-3][m].z;
	}


	//    
	double ro, t, dt = 6.28/(Ntext-1);
	for(int i=0; i<Ntext; i++)
	{
   		t = dt*i;
		ro = 0.5*cos(4.*t)*cos(4.*t);
		ut[i] = ro*cos(t)+0.5;
		vt[i] = ro*sin(t)+0.5;
	}

}


//   
void SurfDestroy()
{
	PostQuitMessage(0);   // 
}

/*
//  
double Bezier(int i, double t)
{
	double b;
	switch(i)
	{
	  case 0  : b=(1-t)*(1-t)*(1-t); break;
	  case 1  : b=3*t*(1-t)*(1-t);   break;
	  case 2  : b=3*t*t*(1-t);       break;
	  case 3  : b=t*t*t;             break;
	}
	return b;
}

*/

// - 
double Bspline(int i, double t)
{
	double b;
	double t2 = t*t, t3 = t2*t;
	switch(i)
	{
	case 0:  b = (1 - 3*t + 3*t2 -   t3)/6; break;
	case 1:  b = (4       - 6*t2 + 3*t3)/6; break;
	case 2:  b = (1 + 3*t + 3*t2 - 3*t3)/6; break;
	case 3:  b =                     t3/6;  break;
	}
	return b;
}




// B- 
POINT3 BsplineSurf(double u, double v)
{
	POINT3 Bz;
	
	double Bzu[4], Bzv[4];
	for(int n=0; n<4; n++)
	{
		Bzu[n] = Bspline(n,u);  Bzv[n] = Bspline(n,v);
	}
	
	Bz.x = 0; Bz.y = 0; Bz.z = 0;
	for(int i=0; i<4; i++)
		for(int j=0; j<4; j++)
		{
			Bz.x += Bzu[i]*Bzv[j]*Ve[i][j].x;
			Bz.y += Bzu[i]*Bzv[j]*Ve[i][j].y;
			Bz.z += Bzu[i]*Bzv[j]*Ve[i][j].z;
		}
	return Bz;
}



//      WM_PAINT
void SurfPaint(HWND hwnd)
{
	PAINTSTRUCT ps;

	//  
	HDC hdcWin = BeginPaint(hwnd, &ps);

	//  
	Picture(hdcWin);

	//  
	EndPaint(hwnd, &ps);
}

//      WM_MOUSEMOVE
void SurfDC(HWND hwnd)
{

	//  
	HDC hdcWin = GetDC(hwnd);

	//  
	Picture(hdcWin);

	//  
	ReleaseDC(hwnd, hdcWin);

}



//  
void Picture(HDC hdcWin)
{
	
	//      
	HDC hdcMem = CreateCompatibleDC(hdcWin); 
	//      
	HBITMAP hBitmap = CreateCompatibleBitmap(hdcWin, ne2, me1); 
    //     
    HBITMAP hBitmapOld = (HBITMAP)SelectObject(hdcMem, hBitmap); 

	//      
	HRGN hrgn1 = CreateRectRgn(ne1,me2-30,ne2,me2-2);

	//    
	HBRUSH hBrush0 = CreateSolidBrush(RGB(0xA6,0xCA,0xF0));
    FillRgn(hdcMem,hrgn1,hBrush0);
	//    
	HBRUSH hBrush1 = CreateSolidBrush(RGB(0xFF,0xFF,0xC0));
	FrameRgn(hdcMem,hrgn1,hBrush1,2,2);

	//      hrgn1
	char ss[10];
	SetBkColor(hdcMem,RGB(0xA6,0xCA,0xF0));
	SetTextColor(hdcMem,RGB(0,0,0x80));
	sprintf(ss,"fi = %4.0lf",angl.fi);
	TextOut(hdcMem,(ne1+ne2)/2-80,me2-25,ss,9);
	sprintf(ss,"teta = %4.0lf",angl.teta);
	TextOut(hdcMem,(ne1+ne2)/2+20,me2-25,ss,11);

	//  hrgn1
	DeleteObject(hrgn1); 

	//       
	HRGN hrgn2 = CreateRectRgn(ne1,me2,ne2,me1);

	//    
	HBRUSH hBrush2 = CreateSolidBrush(RGB(0xC0,0xC0,0xC0));
	FillRgn(hdcMem,hrgn2,hBrush2);

	//   
	SelectClipRgn(hdcMem,hrgn2);

	//       
	sf=sin(3.14159*angl.fi/180);
	cf=cos(3.14159*angl.fi/180);
	st=sin(3.14159*angl.teta/180);
	ct=cos(3.14159*angl.teta/180);


	//  
	Axes(hdcMem);


	SplineSurf(hdcMem);


	//  
	DrawBox(hdcMem, angl);
	
	//     
	BitBlt(hdcWin,ne1,me2-30,ne2,me1,hdcMem,ne1,me2-30,SRCCOPY); 
   

	//   
	DeleteObject(hBrush0);
	DeleteObject(hBrush1);
	DeleteObject(hBrush2);
	DeleteObject(hrgn2);

	SelectObject(hdcMem, hBitmapOld); //  
	DeleteObject(hBitmap); //  
	DeleteDC(hdcMem);  //    
}



//  
void SplineSurf(HDC hdc)
{

	double xt,yt,zt,xe,ye;
	int x1, y1, x2, y2;

//     Vp[Np][Mp]
//  16   Ve[][]  
//B- 

for(int nc=0; nc<Nelm; nc++)
	for(int mc=0; mc<Melm; mc++)
   {

   for(int n=0; n<4; n++)
   	for(int m=0; m<4; m++)
		Ve[n][m] = Vp[n+nc][m+mc];

	// B-   
	// ,   

	HPEN hPen = CreatePen(PS_SOLID,1,RGB(255-100*mc,255-100*nc,100*mc));
	HPEN hPenOld = (HPEN)SelectObject(hdc,hPen);
	
	//" "
	//  
	int Nsp = 2;
	int Ns = 10;
	double v, u, du = 1.0/(Ns-1), dv = 1.0/(Nsp-1);

	for (int i=0; i<Nsp; i++)
	{
   		v = dv*i;
		u = 0;

		xt = BsplineSurf(u,v).x;
		yt = BsplineSurf(u,v).y;
		zt = BsplineSurf(u,v).z;

		xe = Xe(xt,yt);
		ye = Ye(xt,yt,zt);

		x1 = xn(xe);
		y1 = ym(ye);

        MoveToEx(hdc,x1,y1,0);

		for(int j=1; j<Ns; j++)
		{
			u = du*j;

			xt = BsplineSurf(u,v).x;
			yt = BsplineSurf(u,v).y;
			zt = BsplineSurf(u,v).z;

			xe = Xe(xt,yt);
			ye = Ye(xt,yt,zt);

			x1 = xn(xe);
			y1 = ym(ye);

			LineTo(hdc,x1,y1);
		}

	}

	//" "
	//  
	int Msp = 2;
	int Ms = 10;
   	dv = 1.0/(Ms-1); du = 1.0/(Msp-1);

	for ( i=0; i<Msp; i++)
	{
   		u = du*i;
		v = 0;

		xt = BsplineSurf(u,v).x;
		yt = BsplineSurf(u,v).y;
		zt = BsplineSurf(u,v).z;

		xe = Xe(xt,yt);
		ye = Ye(xt,yt,zt);

		x1 = xn(xe);
		y1 = ym(ye);

       	MoveToEx(hdc,x1,y1,0);

		for(int j=1; j<Ms; j++)
		{
			v = dv*j;

			xt = BsplineSurf(u,v).x;
			yt = BsplineSurf(u,v).y;
			zt = BsplineSurf(u,v).z;

			xe = Xe(xt,yt);
			ye = Ye(xt,yt,zt);

			x1 = xn(xe);
			y1 = ym(ye);

			LineTo(hdc,x1,y1);
		}
	}


	//  
	
	xt = BsplineSurf(ut[0],vt[0]).x;
	yt = BsplineSurf(ut[0],vt[0]).y;
	zt = BsplineSurf(ut[0],vt[0]).z;

	xe = Xe(xt,yt);
	ye = Ye(xt,yt,zt);

	x1 = xn(xe);
	y1 = ym(ye);

    MoveToEx(hdc,x1,y1,0);

	for(int k=1; k<Ntext; k++)
	{
		xt = BsplineSurf(ut[k],vt[k]).x;
		yt = BsplineSurf(ut[k],vt[k]).y;
		zt = BsplineSurf(ut[k],vt[k]).z;

		xe = Xe(xt,yt);
		ye = Ye(xt,yt,zt);

		x1 = xn(xe);
		y1 = ym(ye);

		LineTo(hdc,x1,y1);
	}

	//    
	SelectObject(hdc,hPenOld);
	//   
	DeleteObject(hPen);

}

	//       

	HPEN hPen1 = CreatePen(PS_SOLID,1,RGB(255,255,255));
	HPEN hPenOld1 = (HPEN)SelectObject(hdc,hPen1);

	// 
   for(int m = 1; m <Mp-1; m++)
   {
		xe = Xe(Vp[1][m].x,Vp[1][m].y);
		ye = Ye(Vp[1][m].x,Vp[1][m].y,Vp[1][m].z);
		x1=xn(xe);
		y1=ym(ye);
		for(int k=1; k<Np-1; k++)
		{
			xe = Xe(Vp[k][m].x,Vp[k][m].y);
			ye = Ye(Vp[k][m].x,Vp[k][m].y,Vp[k][m].z);
			x2 = xn(xe);
			y2 = ym(ye);
			MoveToEx(hdc,x1,y1,0);
			LineTo(hdc,x2,y2);

			x1 = x2; y1 = y2;
		}
	}

	//  
   for( int k = 1; k <Np-1; k++)
   {
		xe = Xe(Vp[k][1].x,Vp[k][1].y);
		ye = Ye(Vp[k][1].x,Vp[k][1].y,Vp[k][1].z);
		x1=xn(xe);
		y1=ym(ye);
		for(int m=1; m<Mp-1; m++)
		{
			xe = Xe(Vp[k][m].x,Vp[k][m].y);
			ye = Ye(Vp[k][m].x,Vp[k][m].y,Vp[k][m].z);
			x2 = xn(xe);
			y2 = ym(ye);
			MoveToEx(hdc,x1,y1,0);
			LineTo(hdc,x2,y2);

			x1 = x2; y1 = y2;
		}
	}

	

	//    
	SelectObject(hdc,hPenOld1);
	//   
	DeleteObject(hPen1);
	
}




//  
void Axes(HDC hdc)
{
	//    
	HPEN hPen = CreatePen(PS_SOLID,1,RGB(0,255,255));
	HPEN hPenOld = (HPEN)SelectObject(hdc,hPen);

	//      
	double xe, ye;
	// 
	int x1,y1,x2,y2;

	//  Ox
	xe=Xe(-xmax/3,0);
	ye=Ye(-xmax/3,0,0);
	x1=xn(xe);
	y1=ym(ye);             
	xe=Xe(1.5*xmax,0);
	ye=Ye(1.5*xmax,0,0);
	x2=xn(xe);
	y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

	//     
	SetBkColor(hdc,RGB(0xC0,0xC0,0xC0));
	SetTextColor(hdc,RGB(120,120,120));
	TextOut(hdc,x2, y2, "X",1);
	
	//  Oy
	xe=Xe(0,-ymax/3);
	ye=Ye(0,-ymax/3,0);
	x1=xn(xe);
	y1=ym(ye);
	xe=Xe(0,1.5*ymax);
	ye=Ye(0,1.5*ymax,0);
	x2=xn(xe);
	y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

	TextOut(hdc,x2, y2, "Y",1);

	//  Oz
	xe=Xe(0,0);
	ye=Ye(0,0,-zmax/3);
	x1=xn(xe);
	y1=ym(ye);
	xe=Xe(0,0);
	ye=Ye(0,0,1.5*zmax);
	x2=xn(xe);
	y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

	TextOut(hdc,x2, y2, "Z",1);

	//    
	SelectObject(hdc,hPenOld);
	//   
	DeleteObject(hPen);

}

//  -    
void	PointCorns()
{
	Point[0].x =  xmax; Point[0].y =  ymax; Point[0].z = -zmax;
	Point[1].x = -xmax; Point[1].y =  ymax; Point[1].z = -zmax;
	Point[2].x = -xmax; Point[2].y = -ymax; Point[2].z = -zmax;
	Point[3].x =  xmax; Point[3].y = -ymax; Point[3].z = -zmax;
	Point[4].x =  xmax; Point[4].y =  ymax; Point[4].z = zmax;
	Point[5].x = -xmax; Point[5].y =  ymax; Point[5].z = zmax;
	Point[6].x = -xmax; Point[6].y = -ymax; Point[6].z = zmax;
	Point[7].x =  xmax; Point[7].y = -ymax; Point[7].z = zmax;
}


//  
void DrawBox(HDC hdc, ANGLS an)
{

	HPEN hPen = CreatePen(PS_SOLID,1,RGB(160,160,160));
	HPEN hPenOld = (HPEN)SelectObject(hdc,hPen);

   double xe, ye;
	int x1,y1,x2,y2;
	double xt1,yt1,zt1,xt2,yt2,zt2;
   int j;

	for(int i=0; i<4; i++)
	{
		j = i + 1;
		if(j==4)
			j = 0;
		xt1 = Point[i].x; yt1 = Point[i].y; zt1 = Point[i].z;
		xt2 = Point[j].x; yt2 = Point[j].y; zt2 = Point[j].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	for( i=4; i<8; i++)
	{
		j = i + 1;
		if(j==8)
			j = 4;
		xt1 = Point[i].x; yt1 = Point[i].y; zt1 = Point[i].z;
		xt2 = Point[j].x; yt2 = Point[j].y; zt2 = Point[j].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	for( i=0; i<4; i++)
	{
		xt1 =   Point[i].x; yt1 =   Point[i].y; zt1 =   Point[i].z;
		xt2 = Point[i+4].x; yt2 = Point[i+4].y; zt2 = Point[i+4].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	for( i=0; i<2; i++)
	{
		xt1 =   Point[i].x; yt1 =   Point[i].y; zt1 =   Point[i].z;
		xt2 = Point[i+2].x; yt2 = Point[i+2].y; zt2 = Point[i+2].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	//    
	SelectObject(hdc,hPenOld);
	DeleteObject(hPen);

}





//       
inline double Xe(double x,double y)
{
  return -sf*x+cf*y;
}

//       
inline double Ye(double x,double y,double z)
{
  return -ct*cf*x-ct*sf*y+st*z;
}


//     
//   x    n
inline int xn(double x)
{
	return (int)((x - xe1)/(xe2 - xe1)*(ne2 - ne1)) + ne1;
}

//   y    m
inline int ym(double y)
{
	return (int)((y - ye1)/(ye2 - ye1)*(me2 - me1)) + me1;
}






//     
void SurfLButtonDown( int x, int y)
{
	Dat.ButtonDown = TRUE;
	Dat.Drawing = FALSE;

	anglOld.fi = angl.fi;
	anglOld.teta = angl.teta;
	corOld.x = x;
	corOld.y = y;

}



//       
void SurfMouseMove(int x, int y)
{
	if(Dat.ButtonDown)
	{
		Dat.Drawing = TRUE;

		angl.fi += corOld.x-x;
		angl.teta += corOld.y-y;

		corOld.x = x; corOld.y = y;

		anglOld.fi   = angl.fi;
		anglOld.teta   = angl.teta;
	}
}



//       
void SurfLButtonUp()
{
	if(Dat.ButtonDown && Dat.Drawing)
	{
		Dat.Drawing = FALSE;
	}
	Dat.ButtonDown = FALSE;
}





