//   B-


#include <windows.h>     
#include <math.h>
#include <stdio.h>


// 
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void Line_OnPaint(HWND);
void Line_OnCreate(HWND);
double Nbase(int m, int i, double t);


int WINAPI WinMain(HINSTANCE hInstance,       // 
				   HINSTANCE hPrevInstance,
				   LPSTR     lpCmdParam, 
				   int       nCmdShow)     
{

	char cname[] = "Class";     //    
	char title[] = "     Normalized   Base   Functions   of   B-spline ";  //  
	
	MSG msg;    //     
	
	//   
	//------------------------------------------------------------------------
	WNDCLASS wc;  //      

	wc.style          = 0; 
	wc.lpfnWndProc    = (WNDPROC)WndProc;         //  
	wc.cbClsExtra     = 0;       
	wc.cbWndExtra     = 0;       
	wc.hInstance      = hInstance;       // 
	wc.hIcon          = LoadIcon(hInstance, (LPCTSTR)IDI_APPLICATION); 
	wc.hCursor		  = LoadCursor(NULL, IDC_ARROW);  
	wc.hbrBackground  = (HBRUSH)GetStockObject(GRAY_BRUSH);   
	wc.lpszMenuName   = 0;       
	wc.lpszClassName  = cname;      

	if(!RegisterClass(&wc))  //   
		return 0;


	//  
	//------------------------------------------------------------------------
	 HWND hWnd;       //   

	 hWnd = CreateWindow(cname,
						 title,
						 WS_OVERLAPPEDWINDOW,
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 NULL,         // -     
						 NULL,          // 
						 hInstance,     // 
						 NULL);         

	if(!hWnd)
		return 0;



	//  .     ShowWindow,
    //   ,   UpdateWindows,
    //   WM_PAINT   
 	//--------------------------------------------------------------------------
	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd); 


	//    
	//-------------------------------------------------------------------------
  
	while(GetMessage(&msg,NULL,0,0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;


}

// ,  
LRESULT CALLBACK  WndProc(HWND hWnd, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
	
	switch(message)
	{
		//   
		case WM_CREATE:
			Line_OnCreate(hWnd);     
			break;

		//   
		case WM_PAINT:
			Line_OnPaint(hWnd);    //   
			break;

		//   
		case WM_DESTROY:
			PostQuitMessage(0);  //   
			break;

		default:
			return DefWindowProc(hWnd,message,wParam,lParam);
	}

	return 0;

}


//      
double xLeft, xRight, yBottom, yTop;
//       
int    nLeft, nRight, mBottom, mTop;


//  x   n
inline int xn(double x)
{
	return (int)((x - xLeft)/(xRight - xLeft)*(nRight - nLeft)) + nLeft;
}

//  y   m
inline int ym(double y)
{
	return (int)((y - yBottom)/(yTop - yBottom)*(mTop - mBottom)) + mBottom;
}

const int Nvector = 11;
double tv[Nvector+1];


void Line_OnCreate(HWND hwnd)
{
/*
	tv[0] = -3; tv[1] = -2; tv[2] = -1; tv[3] = 0;  tv[4] = 1;  tv[5] = 2;
	tv[6] = 3; tv[7] = 4; tv[8] = 5; tv[9] = 6; tv[10] = 7; tv[11] = 8;  
*/

	tv[0] = 0; tv[1] = 0; tv[2] = 0; tv[3] = 0;  tv[4] = 1;  tv[5] = 1;
	tv[6] = 1; tv[7] = 1; tv[8] = 5; tv[9] = 6; tv[10] = 7; tv[11] = 8;  


}




double Nbase(int m, int i, double t)
{
	if(m == 0)
	{
		if(tv[i]<=t && t<tv[i+1])
			return 1;
		else
			return 0;
	}

	double a,b,f1,f2;
	a = Nbase(m-1, i, t); b = Nbase(m-1,i+1,t);
	if(a == 0)
		f1 = 0;
	else
		f1 = (t-tv[i])*a/(tv[i+m]-tv[i]);

	if(b == 0)
		f2 = 0;
	else
		f2 = (tv[i+m+1]-t)*b/(tv[i+m+1]-tv[i+1]);

	return f1 + f2;
}




//   WM_PAINT
void Line_OnPaint(HWND hwnd)
{
	//       
	xLeft = -3; xRight =  5; yBottom =  -0.3; yTop =  1.3;
	nLeft = 150; nRight = 450; mBottom = 350; mTop = 50;

	//     x   y = sin(x)
	const int N = 1001;
	double corX[N], corY[N];
	double x, y, dx = (xRight - xLeft)/(N-1);


	HDC hdc;                  //  
	PAINTSTRUCT ps;           //       

	hdc = BeginPaint(hwnd, &ps);  //   <hdc>   <hwnd> 

	HBRUSH hbrush, hbrushOld;            // 
	HPEN hpen1, hpen2, hpen3, hpenOld;    // 

	//  <hbrush1>,  - ,  - 
	hbrush = CreateSolidBrush(RGB(0xC0,0xC0,0xC0));
	//  <hbrush>    <hdc>, 
	//    <hbrushOld>
	hbrushOld = (HBRUSH)SelectObject(hdc,hbrush); 

	//  <hpen1>,  - ,  3 ,  - -
	hpen1 = CreatePen(PS_SOLID,3,RGB(100,100,255));
	//  <hpen1>    <hdc>, 
	//    <hpenOld>
	hpenOld = (HPEN)SelectObject(hdc,hpen1);    

	Rectangle(hdc,nLeft,mBottom,nRight,mTop);
	int nb, ne, mb, me;
	POINT  pt;

	HPEN hpen4 = CreatePen(PS_SOLID,1,RGB(150,150,150));
	SelectObject(hdc,hpen4);    	//  <hpen2>    <hdc>

	for(int kk=0; kk<2; kk++)
	{
	//  OX
 	nb = xn(xLeft); mb = ym(kk);
	MoveToEx(hdc, nb, mb, &pt);
	ne = xn(xRight); me = ym(kk);
	LineTo(hdc,ne,me);
	}
	
	for( kk=-3; kk<6; kk++)
	{
	//  OY
	nb = xn(kk); mb = ym(yBottom);
	MoveToEx(hdc, nb, mb, &pt);
	ne = xn(kk); me = ym(yTop);
	LineTo(hdc,ne,me);
	}


	//  <hpen2>,  - ,  1 ,  - -
	hpen2 = CreatePen(PS_SOLID,1,RGB(0,255,255));
	SelectObject(hdc,hpen2);    	//  <hpen2>    <hdc>

		
	//  OX
 	nb = xn(xLeft); mb = ym(0);
	MoveToEx(hdc, nb, mb, &pt);
	ne = xn(xRight); me = ym(0);
	LineTo(hdc,ne,me);

	//  OY
	nb = xn(0); mb = ym(yBottom);
	MoveToEx(hdc, nb, mb, &pt);
	ne = xn(0); me = ym(yTop);
	LineTo(hdc,ne,me);


	//  <hpen2>,  - ,  1 ,  - -


	//   
	SetTextColor(hdc,RGB(255,255,255));
	SetBkColor(hdc,RGB(0xC0,0xC0,0xC0));
	TextOut(hdc,nLeft+160, mTop+30, "N(t)",4);
	TextOut(hdc,nLeft+220, mBottom-40, "t",1);

	//   
	char ss[10];
	sprintf(ss,"%6.1lf",xLeft);
	TextOut(hdc,nLeft+2,mBottom-50,ss,6);
	sprintf(ss,"%6.1lf",xRight);
	TextOut(hdc,nRight-35,mBottom-50,ss,6);
	sprintf(ss,"%6.1lf",yBottom);
	TextOut(hdc,nLeft+120,mBottom-20,ss,6);
	sprintf(ss,"%6.1lf",yTop);
	TextOut(hdc,nLeft+120,mTop+3,ss,6);

	//    


for(int kv=0; kv<4; kv++)
{
	//  <hpen3>,  - ,  2 ,  - -
	hpen3 = CreatePen(PS_SOLID,2,RGB(255,50*kv,50*kv));
	SelectObject(hdc,hpen3);    //  <hpen3>    <hdc>

	for(int i=0; i<N; i++)
	{
		x = xLeft + dx*i; y = Nbase(3,kv,x);
		corX[i] = x; corY[i] = y;
	}

	nb = xn(corX[0]);  mb = ym(corY[0]);
	MoveToEx(hdc, nb, mb, &pt);
	for( i=1; i<N; i++)
	{
		nb = xn(corX[i]);  mb = ym(corY[i]);
		LineTo(hdc,nb,mb);
	}
}
	SelectObject(hdc,hbrushOld); //   <hbrushOld>    <hdc>
	DeleteObject(hbrush);        //  <hbrush>

	SelectObject(hdc,hpenOld);   //   <hpenOld>    <hdc>
	DeleteObject(hpen1);         //  <hpen1>
	DeleteObject(hpen2);         //  <hpen2>
	DeleteObject(hpen3);         //  <hpen3>

	EndPaint(hwnd, &ps);        //   <hdc>   <hwnd>

}

