//B- 
//     3- 

#include <windows.h>     
#include "resource.h"     

#include <math.h>
#include <stdio.h>

// 
HINSTANCE hInstApp;


//  
int    Npoints;
//    Knodel = Npoints + 4
int    Knodal;
//    
int    flagOpen;			 

//  
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK DialProc(HWND, UINT, WPARAM, LPARAM);

void SplineDC(HWND);
void SplineLButtonDown();
void SplineLButtonUp();
void SplineCreate(HWND hWnd);
void SplineMouseMove( HWND hWnd, int x, int y);
void LineDC(HWND hwnd);


int WINAPI WinMain(HINSTANCE hInstance,       // 
				   HINSTANCE hPrevInstance,
				   LPSTR     lpCmdParam, 
				   int       nCmdShow)     
{

	char cname[] = "Spline";     //    
	char title[] = "  B-spline Curves  (Nodal Vector)";  //  
	
	MSG msg;    //     
	
	//   
	//------------------------------------------------------------------------
	WNDCLASS wc;  //      

	wc.style          = 0; 
	wc.lpfnWndProc    = (WNDPROC)WndProc;         //  
	wc.cbClsExtra     = 0;       
	wc.cbWndExtra     = 0;       
	wc.hInstance      = hInstance;       // 
	wc.hIcon          = LoadIcon(hInstance, (LPCTSTR)IDI_APPLICATION); 
	wc.hCursor		  = LoadCursor(NULL, IDC_ARROW);  
	wc.hbrBackground  = (HBRUSH)GetStockObject(LTGRAY_BRUSH);   
	wc.lpszMenuName   = (LPCTSTR)MENU1;       
	wc.lpszClassName  = cname;      

	if(!RegisterClass(&wc))  //   
		return 0;

	hInstApp = hInstance;

	//  
	//------------------------------------------------------------------------
	 HWND hWnd;       //   

	 hWnd = CreateWindow(cname,
						 title,
						 WS_OVERLAPPEDWINDOW,
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 NULL,         // -     
						 NULL,          //   
						 hInstance,     // 
						 NULL);         

	if(!hWnd)
		return 0;



	//  .     ShowWindow,
    //   ,   UpdateWindows,
    //   WM_PAINT   
 	//--------------------------------------------------------------------------
	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd); 


	//    
	//-------------------------------------------------------------------------
  
	while(GetMessage(&msg,NULL,0,0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;


}

// ,  
LRESULT CALLBACK  WndProc(HWND hWnd, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
	// 
	int x, y;
	//     
	int EndDial;
	switch(message)
	{
		//   
		case WM_CREATE:
			SplineCreate(hWnd);  //   
			break;

			//     
		case WM_LBUTTONDOWN:
				SplineLButtonDown();
			break;

		//     
		case WM_LBUTTONUP:
				SplineLButtonUp();
			break;

		//   
		case WM_MOUSEMOVE:
				x = LOWORD(lParam);
				y = HIWORD(lParam);
				SplineMouseMove(hWnd,x,y);
			break;

		//   
		case WM_DESTROY:
			PostQuitMessage(0);  //   
			break;
		
		//   
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case ID_EXIT:
					PostQuitMessage(0);  //   
					break;

				case ID_CLEAN:
					InvalidateRect(hWnd, NULL, TRUE);  //  WM_PAINT
					break;

				case ID_GENERAL:
					EndDial = DialogBox(hInstApp, (LPCTSTR)IDD_DIALOG1, hWnd, DialProc);
		//  . 1-  -   
					//             2-  -     
					//             3-  -   
					//             4-  -    
					
					if(EndDial)
						SplineDC(hWnd);
					break;


				case ID_OPEN_ELEMENTARY_SPLINE:
					flagOpen = 0;
					Npoints = 4;
					SplineDC(hWnd);
					break;

				case ID_CLOSE_ELEMENTARY_SPLINE:
					flagOpen = 1;
					Npoints = 4;
					SplineDC(hWnd);
					break;

				case ID_OPEN_COMPOUND_SPLINE:
					flagOpen = 0;
					EndDial = DialogBox(hInstApp, (LPCTSTR)IDD_DIALOG1, hWnd, DialProc);
		//  . 1-  -   
					//             2-  -     
					//             3-  -   
					//             4-  -    
					
					if(EndDial)
						SplineDC(hWnd);
					break;

				case ID_CLOSE_COMPOUND_SPLINE:
					flagOpen = 1;
					EndDial = DialogBox(hInstApp, (LPCTSTR)IDD_DIALOG1, hWnd, DialProc);
		//  . 1-  -   
					//             2-  -     
					//             3-  -   
					//             4-  -    
					
					if(EndDial)
						SplineDC(hWnd);
					break;


				case ID_CUBIC:
					Npoints = 4;
					SplineDC(hWnd);
					break;
			}
			break;

		default:
			return DefWindowProc(hWnd,message,wParam,lParam);
	}

	return 0;

}


//  
BOOL CALLBACK DialProc(HWND hwndDlg, UINT uMsg,
	                      WPARAM wParam, LPARAM lParam)
{
	char S[10];
	switch(uMsg)
	{
		//    
		case WM_INITDIALOG:
			sprintf(S,"%d",4);
			SetWindowText(GetDlgItem(hwndDlg, IDC_EDIT1), S);
			break;

		//    
		case WM_CLOSE:
			EndDialog(hwndDlg, 0);
			break;

		//,     
		case WM_COMMAND:
			if(LOWORD(wParam) == IDCANCEL)  // 
			{
				EndDialog(hwndDlg, 0);
			}
			if(LOWORD(wParam) == IDOK)  // 
			{
				GetWindowText(GetDlgItem(hwndDlg, IDC_EDIT1), S, 10);
				Npoints = atoi(S);
				if(Npoints > 20)
					Npoints = 20;
				if(Npoints < 4)
					Npoints = 4;

				EndDialog(hwndDlg, 1);
			}
			break;
	}
	return 0;
}






struct POINT2 {
	double x, y;
};

//  
POINT2 V[21];



//    
double tv[25];






//      
double xLeft, xRight, yBottom, yTop;
//       
int    nLeft, nRight, mBottom, mTop;

//
int flagDown, flagUp, flagLock;
//   
int Nlock;


//  x   n
inline int xn(double x)
{
	return (int)((x - xLeft)/(xRight - xLeft)*(nRight - nLeft)) + nLeft;
}

//  y   m
inline int ym(double y)
{
	return (int)((y - yBottom)/(yTop - yBottom)*(mTop - mBottom)) + mBottom;
}

// 
double Fact(int N)
{
	double p=1;
	if(N != 0)
		for(int n=1; n<=N; n++)
			p *= n;
	return p;
}

//    
inline double Cb(int N, int i)
{
	return Fact(N)/Fact(i)/Fact(N-i);
}

//  
double Bezie(int N, int i, double t)
{
	double b;
	double p1 = 1, p2 = 1;
	if(i != 0)
		for(int in=0; in<i; in++)
			p1 *= t;
	if((N-i) != 0)
		for(int in=0; in<(N-i); in++)
			p2 *= 1-t;
	b = Cb(N,i)*p1*p2;
		
	return b;
}


//   
POINT2 splineBezie(int N, double t)
{
  POINT2 S;
  S.x = 0; S.y = 0;
  for(int i=0; i<=N; i++)
  {
	double Bez =  Bezie(N,i,t);
	 S.x += V[i].x*Bez;
	 S.y += V[i].y*Bez;
  }
  return S;
}

//  B-
double Nbase(int m, int i, double t)
{
	if(m == 0)
	{
		if(tv[i]<=t && t<tv[i+1])
			return 1;
		else
			return 0;
	}

	double a,b,f1,f2;
	a = Nbase(m-1, i, t); b = Nbase(m-1,i+1,t);
	if(a == 0)
		f1 = 0;
	else
		f1 = (t-tv[i])*a/(tv[i+m]-tv[i]);

	if(b == 0)
		f2 = 0;
	else
		f2 = (tv[i+m+1]-t)*b/(tv[i+m+1]-tv[i+1]);

	return f1 + f2;
}

//   
POINT2 BsplineBase(int N, int m, double t)
{
  POINT2 S;
  S.x = 0; S.y = 0;
  for(int i=0; i<=N; i++)
  {
	double Nbas =  Nbase(m,i,t);
	 S.x += V[i].x*Nbas;
	 S.y += V[i].y*Nbas;
  }
  return S;
}


//  WM_LBUTTONDOWN
void SplineLButtonDown()
{
	flagUp   = 0;
	flagDown = 1;
}

//  WM_LBUTTONUP
void SplineLButtonUp()
{
	flagUp   = 1;
	flagDown = 0;
	flagLock = 0;
}



//  WM_CREATE
void SplineCreate(HWND hWnd)
{

	flagOpen = 0;
	flagDown = 0; flagUp = 0; flagLock = 0;
}


//   n  x 
inline double nx(int n)
{
	return (n - nLeft)*(xRight - xLeft)/(nRight - nLeft) + xLeft;
}

//   m  y 
inline double my(int m)
{
	return (m - mBottom)*(yTop - yBottom)/(mTop - mBottom) + yBottom;
}


void SplineMouseMove(HWND hwnd,int x, int y)
{
	if(flagDown)
	{
		if(!flagLock)
			for(int i=0; i<Npoints; i++)
				if(abs(x-xn(V[i].x))+abs(y-ym(V[i].y))<10)
				{
					Nlock = i;
					flagLock = 1;
				}
		if(flagLock)
		{
			V[Nlock].x = nx(x);  V[Nlock].y = my(y);
			LineDC(hwnd);
		}
	}
}





//   WM_COMMON
void SplineDC(HWND hwnd)
{

	
	RECT rc;
	GetClientRect(hwnd,&rc); //     <hwnd>

	//       
	xLeft = -10; xRight =  10; yBottom =  -6; yTop =  6;
	nLeft = rc.left; nRight = rc.right; mBottom = rc.bottom; mTop = rc.top;


//       
	double kr = 0.75;
	for(int i=0; i<Npoints; i++)
	{
		V[i].x = kr*(xLeft + rand()*(xRight - xLeft)/RAND_MAX);
		V[i].y = kr*(yBottom + rand()*(yTop - yBottom)/RAND_MAX);
	}

//       B-
	Knodal = Npoints + 4;
	for(int nv=0; nv<Knodal; nv++)
		tv[nv] = -3 + nv;

//        B-
	if(flagOpen == 1)
			for(int en=0; en<3; en++)
			{
				tv[en] = 0; 
				tv[Npoints+en+1] = Npoints - 3;
			}





	HDC hdc;            //  
	hdc = GetDC(hwnd);  //   <hdc>   <hwnd>


	HPEN hpen1 = CreatePen(PS_SOLID,1,RGB(0,255,255));
	HPEN hpenOld = (HPEN)SelectObject(hdc,hpen1);    

	int nb, ne, mb, me;

	//  OX
 	nb = xn(xLeft); mb = ym(0);
	MoveToEx(hdc, nb, mb, NULL);
	ne = xn(xRight); me = ym(0);
	LineTo(hdc,ne,me);

	//  OY
	nb = xn(0); mb = ym(yBottom);
	MoveToEx(hdc, nb, mb, NULL);
	ne = xn(0); me = ym(yTop);
	LineTo(hdc,ne,me);


	char str[200] = "";
	char ss[10];
	strcat(str,"[");
	for(int is=0; is<Knodal; is++)
	{
		sprintf(ss,"%3d",int(tv[is]));
		strcat(str,ss);
	}
	strcat(str," ]");

	SetBkColor(hdc,RGB(0xC0,0xC0,0xC0));
	SetTextColor(hdc,RGB(0,0,0x80));
		TextOut(hdc,nLeft+30, 5, "Nodal Vector",12);
		TextOut(hdc,nLeft+30, 20, str,3*Knodal+3);





	HPEN hpen2 = CreatePen(PS_SOLID,2,RGB(255,255,255));
	SelectObject(hdc,hpen2);    
//     
	MoveToEx(hdc,xn(V[0].x),ym(V[0].y),0);
	for( i=1; i<Npoints; i++)
		LineTo(hdc,xn(V[i].x),ym(V[i].y));

	HPEN hpen3 = CreatePen(PS_SOLID,2,RGB(0,255,0));
	SelectObject(hdc,hpen3);    
//  B-
		int Nt = 20*Npoints;
		double t, dt = (Npoints-3.0)/(Nt-1.0);
		MoveToEx(hdc,xn(BsplineBase(Npoints,3,0).x),ym(BsplineBase(Npoints,3,0).y),0);
		for(int p=1; p<Nt; p++)
		{
			t = dt*p;
			if(p == Nt-1)
				t -= 0.00001;
			LineTo(hdc,xn(BsplineBase(Npoints,3,t).x),ym(BsplineBase(Npoints,3,t).y));
		}

	HPEN hpen4 = CreatePen(PS_SOLID,1,RGB(0,255,255));
	SelectObject(hdc,hpen4);    
	HBRUSH hbrush = CreateSolidBrush(RGB(255,0,0));
	HBRUSH hbrushOld = (HBRUSH)SelectObject(hdc,hbrush); 
//     
	for(i=0; i<Npoints; i++)
	{
		int x1, y1;
		x1 = xn(V[i].x); y1 = ym(V[i].y);
		Ellipse(hdc, x1-4, y1-4, x1+4, y1+4);
		sprintf(ss,"V%d",i);
		if(i<10)
		TextOut(hdc,x1-20-2*i, y1-10+1*i, ss,2);
		else
		TextOut(hdc,x1-20-2*i, y1-10+1*i, ss,3);
	}


	SelectObject(hdc,hbrushOld);   
	SelectObject(hdc,hpenOld);   
	DeleteObject(hpen1);         
	DeleteObject(hpen2);         
	DeleteObject(hpen3);         
	DeleteObject(hpen4);         
	DeleteObject(hbrush);         
	
	ReleaseDC(hwnd, hdc);  

}


void LineDC(HWND hwnd)
{
	HDC hdc = GetDC(hwnd);  //   <hdc>   <hwnd>

	//   hdcMem,     hdc
	HDC hdcMem = CreateCompatibleDC(hdc);
	// ()      
	HBITMAP hBmp = CreateCompatibleBitmap(hdc, nRight, mBottom); 
	//   hBmp    hdcMem
	HBITMAP hBmpOld = (HBITMAP)SelectObject(hdcMem, hBmp); 

	HPEN hpen0 = CreatePen(PS_SOLID,2,RGB(0xC0,0xC0,0xC0));
	HPEN hpenOld = (HPEN)SelectObject(hdcMem,hpen0);    
	HBRUSH hbrush0 = CreateSolidBrush(RGB(0xC0,0xC0,0xC0));
	HBRUSH hbrushOld = (HBRUSH)SelectObject(hdcMem,hbrush0); 

	Rectangle(hdcMem,0,0,nRight,mBottom);


	HPEN hpen1 = CreatePen(PS_SOLID,2,RGB(0,255,255));
	SelectObject(hdcMem,hpen1);    

	int nb, mb, ne, me;
	//  OX
 	nb = xn(xLeft); mb = ym(0);
	MoveToEx(hdcMem, nb, mb, NULL);
	ne = xn(xRight); me = ym(0);
	LineTo(hdcMem,ne,me);

	//  OY
	nb = xn(0); mb = ym(yBottom);
	MoveToEx(hdcMem, nb, mb, NULL);
	ne = xn(0); me = ym(yTop);
	LineTo(hdcMem,ne,me);


	char str[200] = "";
	char ss[10];
	strcat(str,"[");
	for(int is=0; is<Knodal; is++)
	{
		sprintf(ss,"%3d",int(tv[is]));
		strcat(str,ss);
	}
	strcat(str," ]");

	SetBkColor(hdcMem,RGB(0xC0,0xC0,0xC0));
	SetTextColor(hdcMem,RGB(0,0,0x80));
		TextOut(hdcMem,nLeft+30, 5, "Nodal Vector",12);
		TextOut(hdcMem,nLeft+30, 20, str,3*Knodal+3);




	HPEN hpen2 = CreatePen(PS_SOLID,2,RGB(255,255,255));
	SelectObject(hdcMem,hpen2);    
//     
	MoveToEx(hdcMem,xn(V[0].x),ym(V[0].y),0);
	for( int i=1; i<Npoints; i++)
		LineTo(hdcMem,xn(V[i].x),ym(V[i].y));

	HPEN hpen3 = CreatePen(PS_SOLID,2,RGB(0,255,0));
	SelectObject(hdcMem,hpen3);    

//  B-
		int Nt = 20*Npoints;
		double t, dt = (Npoints-3.0)/(Nt-1.0);
		MoveToEx(hdcMem,xn(BsplineBase(Npoints,3,0).x),ym(BsplineBase(Npoints,3,0).y),0);
		for(int p=1; p<Nt; p++)
		{
			t = dt*p;
			if(p == Nt-1)
				t -= 0.00001;
			LineTo(hdcMem,xn(BsplineBase(Npoints,3,t).x),ym(BsplineBase(Npoints,3,t).y));
		}


	HPEN hpen4 = CreatePen(PS_SOLID,1,RGB(0,255,255));
	SelectObject(hdcMem,hpen4);    
	HBRUSH hbrush = CreateSolidBrush(RGB(255,0,0));
	SelectObject(hdcMem,hbrush); 
//     
	for(i=0; i<Npoints; i++)
	{
		int x1, y1;
		x1 = xn(V[i].x); y1 = ym(V[i].y);
		Ellipse(hdcMem, x1-4, y1-4, x1+4, y1+4);
		sprintf(ss,"V%d",i);
		if(i<10)
		TextOut(hdcMem,x1-20-2*i, y1-10+1*i, ss,2);
		else
		TextOut(hdcMem,x1-20-2*i, y1-10+1*i, ss,3);
	}
	
	

//     
	BitBlt(hdc, 0, 0, nRight, mBottom, hdcMem, 0, 0, SRCCOPY);

	SelectObject(hdcMem,hbrushOld); 
	DeleteObject(hbrush0);        
	DeleteObject(hbrush);        

	SelectObject(hdcMem,hpenOld);   
	DeleteObject(hpen0);         
	DeleteObject(hpen1);         
	DeleteObject(hpen2);         
	DeleteObject(hpen3);         
	DeleteObject(hpen4);         
	DeleteObject(hBmp);               
	DeleteDC(hdcMem);                 

	ReleaseDC(hwnd, hdc);  

}

