//    ()
//   'T'    'K'

//     ()
//   


#define STRICT
#include <windows.h>
#include <math.h>
#include <stdio.h>



// 
char const szClassName[] = "LineClass";
// 
char const szWindowTitle[] = "Korneev V.        "
			"   Bezie SplineLine,       "
			"   T - tangent vector,  K - curvature vector  "
			"   rotation  by  mouse  and  keyboard (arrows)";



struct TDATA {

	BOOL ButtonDown;
	BOOL Drawing;
};

static TDATA Dat;

struct ANGLS {
	double fi, teta;
};

static ANGLS angl,anglOld;

struct CORD {
	int x, y;
};

static CORD corOld;

struct POINT3 {
	double x, y, z;
};

static POINT3 Point[8];



// 
BOOL RegisterApp(HINSTANCE hInst);
HWND CreateApp(HINSTANCE, int);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void LineCreate();
void LineDestroy();
void LinePaint(HWND);
void LineLButtonDown(HWND,int,int);
void LineMouseMove(HWND,int,int);
void DrawLine(HWND, HDC, ANGLS);
void LineLButtonUp(HWND);
void PointCorns();


//  -    
int WINAPI WinMain(HINSTANCE hInst,
						 HINSTANCE hPrevInstance,
						 LPSTR     lpszCmdParam,
						 int       nCmdShow)
{
	MSG msg;

	if(!RegisterApp(hInst))  // 
		return FALSE;

	if(!CreateApp(hInst,nCmdShow))  // 
		return FALSE;

	while(GetMessage(&msg,NULL,0,0))   //  
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}

// 
BOOL RegisterApp(HINSTANCE hInst)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInst;
	wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor		  = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(LTGRAY_BRUSH);
	wc.lpszClassName = szClassName;

	return RegisterClass(&wc);
}



//  
HWND CreateApp(HINSTANCE hInstance, int nCmdShow)
{
	 HWND hwnd;

	 hwnd = CreateWindow(szClassName,
									 szWindowTitle,
									 WS_OVERLAPPEDWINDOW,
                            100, //x -  .. 
                            50,  //y -  .. 
                            650, // 
                            500, // 
									 NULL,
									 NULL,
									 hInstance,
									 NULL);

	if(hwnd == NULL)
		return hwnd;

	ShowWindow(hwnd,nCmdShow);
	UpdateWindow(hwnd);

	return hwnd;
}







//   
LRESULT CALLBACK  WndProc(HWND hwnd, UINT msg,
											WPARAM wParam, LPARAM lParam)
{

	int x,y;
	switch(msg)
	{
		case WM_CREATE:
			LineCreate();
			break;

		case WM_PAINT:
			LinePaint(hwnd);
			break;

		case WM_LBUTTONDOWN:
				x = LOWORD(lParam);
				y = HIWORD(lParam);
				LineLButtonDown(hwnd,x,y);
			break;

		case WM_LBUTTONUP:
				LineLButtonUp(hwnd);
				InvalidateRect(hwnd,NULL,TRUE);
			break;


		case WM_MOUSEMOVE:
				x = LOWORD(lParam);
				y = HIWORD(lParam);

				LineMouseMove( hwnd,x,y);
			break;

		case WM_KEYDOWN:
			switch(wParam)
			{
				case VK_LEFT:
					angl.fi += 10;
					InvalidateRect(hwnd,NULL,TRUE);
					break;

				case VK_RIGHT:
					angl.fi -= 10;
					InvalidateRect(hwnd,NULL,TRUE);
					break;

				case VK_UP:
					angl.teta += 10;
					InvalidateRect(hwnd,NULL,TRUE);
					break;

				case VK_DOWN:
					angl.teta -= 10;
					InvalidateRect(hwnd,NULL,TRUE);
					break;
			}
			break;

		case WM_DESTROY:
			LineDestroy();
			break;

		default:
			return DefWindowProc(hwnd,msg,wParam,lParam);
	}

	return 0L;
}



// 
//   
double Px[4], Py[4], Pz[4];
 //        
double xe1, xe2, ye1, ye2;
int    ne1, ne2, me1, me2;

// 
//    -  
  double xmax, ymax, zmax;



//    
void LineCreate()
{
//        
	xe1 = -3;  xe2 =   3; ye1 =  -3; ye2 =  3;
	ne1 = 175; ne2 = 475; me1 = 375; me2 = 75;

//    -  
	xmax=2., ymax=2., zmax=2.;

	PointCorns();

//    -  
	angl.fi = 30; angl.teta = 60;

//       
	Px[0] =  2.0;  Py[0] =  0.0;  Pz[0] =  0.0;
	Px[1] =  2.0;  Py[1] =  2.8;  Pz[1] =  0.0;
	Px[2] = -2.0;  Py[2] =  2.8;  Pz[2] =  0.0;
	Px[3] = -2.0;  Py[3] =  0.0;  Pz[3] =  0.0;


}

//   -    
void	PointCorns()
{
	Point[0].x =  xmax; Point[0].y =  ymax; Point[0].z = -zmax;
	Point[1].x = -xmax; Point[1].y =  ymax; Point[1].z = -zmax;
	Point[2].x = -xmax; Point[2].y = -ymax; Point[2].z = -zmax;
	Point[3].x =  xmax; Point[3].y = -ymax; Point[3].z = -zmax;
	Point[4].x =  xmax; Point[4].y =  ymax; Point[4].z = zmax;
	Point[5].x = -xmax; Point[5].y =  ymax; Point[5].z = zmax;
	Point[6].x = -xmax; Point[6].y = -ymax; Point[6].z = zmax;
	Point[7].x =  xmax; Point[7].y = -ymax; Point[7].z = zmax;
}

void LineDestroy()
{
	PostQuitMessage(0);   // 
}

//  -  
double sf,cf,st,ct;

//  
double Bezie(int i, double t)
{
	double b;
	switch(i)
	{
	  case 0  : b=(1-t)*(1-t)*(1-t); break;
	  case 1  : b=3*t*(1-t)*(1-t);   break;
	  case 2  : b=3*t*t*(1-t);       break;
	  case 3  : b=t*t*t;             break;
	}
	return b;
}

//     
double BezieDer1(int i, double t)
{
	double b;
	switch(i)
	{
	  case 0  : b=-3+6*t-3*t*t; break;
	  case 1  : b=3-12*t+9*t*t;   break;
	  case 2  : b=6*t-9*t*t;       break;
	  case 3  : b=3*t*t;             break;
	}
	return b;
}

//     
double BezieDer2(int i, double t)
{
	double b;
	switch(i)
	{
	  case 0  : b=6-6*t; break;
	  case 1  : b=-12+18*t;   break;
	  case 2  : b=6-18*t;       break;
	  case 3  : b=6*t;             break;
	}
	return b;
}


//X-    
double splineX(double t)
{
  double S=0;
  for(int i=0; i<4; i++)
	 S += Px[i]*Bezie(i,t);
  return S;
}

//Y-    
double splineY(double t)
{
  double S=0;
  for(int i=0; i<4; i++)
	 S += Py[i]*Bezie(i,t);
  return S;
}

//Z-    
double splineZ(double t)
{
  double S=0;
  for(int i=0; i<4; i++)
	 S += Pz[i]*Bezie(i,t);
  return S;
}



//X-      
double splineXDer1(double t)
{
  double S=0;
  for(int i=0; i<4; i++)
	 S += Px[i]*BezieDer1(i,t);
  return S;
}

//Y-      
double splineYDer1(double t)
{
  double S=0;
  for(int i=0; i<4; i++)
	 S += Py[i]*BezieDer1(i,t);
  return S;
}

//Z-      
double splineZDer1(double t)
{
  double S=0;
  for(int i=0; i<4; i++)
	 S += Pz[i]*BezieDer1(i,t);
  return S;
}



//X-      
double splineXDer2(double t)
{
  double S=0;
  for(int i=0; i<4; i++)
	 S += Px[i]*BezieDer2(i,t);
  return S;
}

//Y-      
double splineYDer2(double t)
{
  double S=0;
  for(int i=0; i<4; i++)
	 S += Py[i]*BezieDer2(i,t);
  return S;
}

//Z-      
double splineZDer2(double t)
{
  double S=0;
  for(int i=0; i<4; i++)
	 S += Pz[i]*BezieDer2(i,t);
  return S;
}



//       
double Xe(double x,double y)
{
  return -sf*x+cf*y;
}

//       
double Ye(double x,double y,double z)
{
  return -ct*cf*x-ct*sf*y+st*z;
}

//     
//   x    n
inline int xn(double x)
{
	return (int)((x - xe1)/(xe2 - xe1)*(ne2 - ne1)) + ne1;
}

//   y    m
inline int ym(double y)
{
	return (int)((y - ye1)/(ye2 - ye1)*(me2 - me1)) + me1;
}

double M_PI = 3.14159;


// 2D -  R
void curvPoint(HDC hdc, int x, int y, int R, COLORREF rgb)
{
	HBRUSH hBrush = CreateSolidBrush(rgb);
	HBRUSH hBrushOld = (HBRUSH)SelectObject(hdc,hBrush);     //  hbrush
	HPEN hPen = CreatePen(PS_SOLID,1,rgb);
	HPEN hPenOld = (HPEN)SelectObject(hdc,hPen);         //   hpen
	
	Ellipse(hdc, x-R, y-R, x+R, y+R );

	SelectObject(hdc,hPenOld);
	DeleteObject(hPen);
	SelectObject(hdc,hBrushOld);
	DeleteObject(hBrush);

}


// 2D -
void arrowVector(HDC hdc, int x1, int y1, int x2, int y2, COLORREF rgb)
{

	int x3, y3, x4, y4, x0, y0;
	x0 = int(0.85*(x2 - x1)) + x1;
	y0 = int(0.85*(y2 - y1)) + y1;
	x3 = -int(0.07*(y2 - y1)) + x0;
	y3 = int(0.07*(x2 - x1)) + y0;
	x4 = int(0.07*(y2 - y1)) + x0;
	y4 = -int(0.07*(x2 - x1)) + y0;

	HPEN hPen = CreatePen(PS_SOLID,2,rgb);
	HPEN hPenOld = (HPEN)SelectObject(hdc,hPen);
	
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);
	MoveToEx(hdc,x3,y3,0);
	LineTo(hdc,x2,y2);
	LineTo(hdc,x4,y4);

	SelectObject(hdc,hPenOld);
	DeleteObject(hPen);
}

//   'T'    'K'
//kT, kK -     'T'  'K'
void TangCurvVector(HDC hdc, double t, double kT, double kK, COLORREF rgbText, COLORREF rgbVect)
{
	double xt0, yt0, zt0, xt, yt, zt, xe, ye;
	int x1, y1, x2, y2;

//    
			xt0 = splineX(t);
			yt0 = splineY(t);
			zt0 = splineZ(t);
//     
			xe = Xe(xt0,yt0);
			ye = Ye(xt0,yt0,zt0);
//     
			x1 = xn(xe);
			y1 = ym(ye);

	double ax, ay, az, al;
//   -  
	ax = splineXDer1(t);
	ay = splineYDer1(t);
	az = splineZDer1(t); 
	al = sqrt(ax*ax + ay*ay + az*az);

//    
			xt = xt0 + kT*ax/al;
			yt = yt0 + kT*ay/al;
			zt = zt0 + kT*az/al;
//     
			xe = Xe(xt,yt);
			ye = Ye(xt,yt,zt);
//     
			x2 = xn(xe);
			y2 = ym(ye);
	
	arrowVector(hdc, x1, y1, x2, y2, rgbVect);
	SetTextColor(hdc,rgbText);
	TextOut(hdc, int((1.3*(x2 - x1)))+x1, int((1.3*(y2 - y1)))+y1, "T",1);

	double bx, by, bz, cx, cy, cz;
//   -  
	bx = splineXDer2(t);
	by = splineYDer2(t);
	bz = splineZDer2(t); 
	double aa,ab;
	aa = ax*ax + ay*ay + az*az;
	ab = ax*bx + ay*by + az*bz;
	cx = aa*bx - ab*ax;
	cy = aa*by - ab*ay;
	cz = aa*bz - ab*az;

//    
			xt = xt0 + kK*cx/al/al/al/al;
			yt = yt0 + kK*cy/al/al/al/al;
			zt = zt0 + kK*cz/al/al/al/al;
//     
			xe = Xe(xt,yt);
			ye = Ye(xt,yt,zt);
//     
			x2 = xn(xe);
			y2 = ym(ye);

	arrowVector(hdc, x1, y1, x2, y2, rgbVect);
	TextOut(hdc, int((1.3*(x2 - x1)))+x1, int((1.3*(y2 - y1)))+y1, "K",1);

}


//    
void LinePaint(HWND hwnd)
{
	HDC hdc;
	PAINTSTRUCT ps;

	hdc = BeginPaint(hwnd, &ps);



	sf=sin(M_PI*angl.fi/180);
	cf=cos(M_PI*angl.fi/180);
	st=sin(M_PI*angl.teta/180);
	ct=cos(M_PI*angl.teta/180);

	HRGN hrgnClip1 = CreateRectRgn(ne1+60,me2-30,ne1+250,me2-2);
	SelectClipRgn(hdc,hrgnClip1);
	HBRUSH hBrush1 = CreateSolidBrush(RGB(255,0,255));
	FrameRgn(hdc,hrgnClip1,hBrush1,2,2);

   char ss[10];
	SetBkColor(hdc,RGB(0xC0,0xC0,0xC0));
	SetTextColor(hdc,RGB(0,0,0x80));
   sprintf(ss,"fi = %4.0lf",angl.fi);
   TextOut(hdc,(ne1+ne2)/2-80,me2-25,ss,9);
   sprintf(ss,"teta = %4.0lf",angl.teta);
   TextOut(hdc,(ne1+ne2)/2+20,me2-25,ss,11);

	DeleteObject(hrgnClip1);

	HRGN hrgnClip = CreateRectRgn(ne1,me2,ne2,me1);
	SelectClipRgn(hdc,hrgnClip);

//  
	MoveToEx(hdc,ne1,me2,0);
	LineTo(hdc,ne2-1,me2);
	LineTo(hdc,ne2-1,me1-1);
	LineTo(hdc,ne1,me1-1);
	LineTo(hdc,ne1,me2);

	HPEN hPen1 = CreatePen(PS_SOLID,1,RGB(0,255,255));
	HPEN hPenOld = (HPEN)SelectObject(hdc,hPen1);

//      
  double xe, ye;
// 
	int x1,y1,x2,y2;

//  Ox
		xe=Xe(-xmax,0);
		ye=Ye(-xmax,0,0);
		x1=xn(xe);
		y1=ym(ye);
		xe=Xe(1.5*xmax,0);
		ye=Ye(1.5*xmax,0,0);
		x2=xn(xe);
		y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

	SetTextColor(hdc,RGB(120,120,120));
	TextOut(hdc,x2, y2, "X",1);

//  Oy
		xe=Xe(0,-ymax);
		ye=Ye(0,-ymax,0);
		x1=xn(xe);
		y1=ym(ye);
		xe=Xe(0,1.5*ymax);
		ye=Ye(0,1.5*ymax,0);
		x2=xn(xe);
		y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

	TextOut(hdc,x2, y2, "Y",1);

//  Oz
		xe=Xe(0,0);
		ye=Ye(0,0,-zmax/3);
		x1=xn(xe);
		y1=ym(ye);
		xe=Xe(0,0);
		ye=Ye(0,0,1.5*zmax);
		x2=xn(xe);
		y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

	TextOut(hdc,x2, y2, "Z",1);

//    						
	HPEN hPen2 = CreatePen(PS_SOLID,1,RGB(255,255,255));
	SelectObject(hdc,hPen2);

/*
	xe = Xe(Px[0],Py[0]);
		ye = Ye(Px[0],Py[0],Pz[0]);
		x1=xn(xe);
		y1=ym(ye);
		for(int k=1; k<4; k++)
		{
			xe = Xe(Px[k],Py[k]);
			ye = Ye(Px[k],Py[k],Pz[k]);
			x2 = xn(xe);
			y2 = ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

			x1 = x2; y1 = y2;
		}

*/
	HPEN hPen3 = CreatePen(PS_SOLID,3,RGB(255,0,0));
	SelectObject(hdc,hPen3);
	
	
	//    
	int J=21;
	double xt, yt, zt, t, dt = 1.0/(J-1);

//    
			xt = splineX(0);
			yt = splineY(0);
			zt = splineZ(0);
//     
			xe = Xe(xt,yt);
			ye = Ye(xt,yt,zt);
//     
			x1 = xn(xe);
			y1 = ym(ye);

	MoveToEx(hdc,x1,y1,0);
		for(int j=1; j<J; j++)
		{
			t = dt*j;
//    
			xt = splineX(t);
			yt = splineY(t);
			zt = splineZ(t);
//     
			xe = Xe(xt,yt);
			ye = Ye(xt,yt,zt);
//     
			x1 = xn(xe);
			y1 = ym(ye);
//   
	LineTo(hdc,x1,y1);
		}

//    
//    
			xt = splineX(0);
			yt = splineY(0);
			zt = splineZ(0);
//     
			xe = Xe(xt,yt);
			ye = Ye(xt,yt,zt);
//     
			x1 = xn(xe);
			y1 = ym(ye);

	curvPoint(hdc, x1, y1, 4, RGB(100,255,0));	
	TextOut(hdc,x1-15, y1-10, "1",1);


//    
//    
			xt = splineX(1);
			yt = splineY(1);
			zt = splineZ(1);
//     
			xe = Xe(xt,yt);
			ye = Ye(xt,yt,zt);
//     
			x1 = xn(xe);
			y1 = ym(ye);

	curvPoint(hdc, x1, y1, 4, RGB(100,255,0));	
	TextOut(hdc,x1-15, y1-10, "2",1);
	TextOut(hdc,x1+15, y1+18, "C",1);


	double t0 = 0.5;

//    t0
//    
			xt = splineX(t0);
			yt = splineY(t0);
			zt = splineZ(t0);
//     
			xe = Xe(xt,yt);
			ye = Ye(xt,yt,zt);
//     
			x1 = xn(xe);
			y1 = ym(ye);

	curvPoint(hdc, x1, y1, 6, RGB(100,0,255));	
	TextOut(hdc,x1-5, y1+20, " M(x,y,z)",9);

	//     
	TangCurvVector(hdc, t0, 2, 2.5, RGB(120,120,120), RGB(255,255,0));


//   
	HPEN hPen8 = CreatePen(PS_SOLID,1,RGB(160,160,160));
	SelectObject(hdc,hPen8);

		DrawLine(hwnd, hdc, angl);

	SelectObject(hdc,hPenOld);
	DeleteObject(hPen1);
	DeleteObject(hPen2);
	DeleteObject(hPen3);
	DeleteObject(hPen8);

	DeleteObject(hBrush1);

	DeleteObject(hrgnClip);
	EndPaint(hwnd, &ps);
}





//       
void LineLButtonDown(HWND hwnd, int x, int y)
{
	Dat.ButtonDown = TRUE;
	Dat.Drawing = FALSE;

   anglOld.fi = angl.fi;
	anglOld.teta = angl.teta;
	corOld.x = x;
	corOld.y = y;

	HDC PaintDC = GetDC(hwnd);
	HRGN hrgnClip = CreateRectRgn(ne1,me2,ne2,me1);
	SelectClipRgn(PaintDC,hrgnClip);
	HPEN hPen, hPenOld;

	hPen = CreatePen(PS_SOLID,1,RGB(0,0,255));
	hPenOld = (HPEN)SelectObject(PaintDC,hPen);

	SetROP2(PaintDC, R2_NOTXORPEN);
	DrawLine(hwnd, PaintDC, anglOld);

	SelectObject(PaintDC,hPenOld);
	DeleteObject(hPen);

	DeleteObject(hrgnClip);
	ReleaseDC(hwnd, PaintDC);
}

//       
//        
void LineMouseMove(HWND hwnd,int x, int y)
{
	if(Dat.ButtonDown)
	{
		Dat.Drawing = TRUE;

		HDC PaintDC = GetDC(hwnd);
	HRGN hrgnClip = CreateRectRgn(ne1,me2,ne2,me1);
	SelectClipRgn(PaintDC,hrgnClip);
		HPEN hPen, hPenOld;

		hPen = CreatePen(PS_SOLID,1,RGB(0,0,255));
		hPenOld = (HPEN)SelectObject(PaintDC,hPen);

		SetROP2(PaintDC, R2_NOTXORPEN);
		DrawLine(hwnd, PaintDC, anglOld);

		angl.fi += corOld.x-x;
		angl.teta += corOld.y-y;
		corOld.x = x; corOld.y = y;

		anglOld.fi   = angl.fi;
		anglOld.teta   = angl.teta;

		DrawLine(hwnd, PaintDC, anglOld);

		SelectObject(PaintDC,hPenOld);
   	DeleteObject(hPen);

	DeleteObject(hrgnClip);
		ReleaseDC(hwnd, PaintDC);
	}
}


//       
void DrawLine(HWND hwnd, HDC hdc, ANGLS an)
{
	sf=sin(M_PI*an.fi/180);
	cf=cos(M_PI*an.fi/180);
	st=sin(M_PI*an.teta/180);
	ct=cos(M_PI*an.teta/180);

   double xe, ye;
	int x1,y1,x2,y2;
	double xt1,yt1,zt1,xt2,yt2,zt2;
   int j;

	for(int i=0; i<4; i++)
	{
		j = i + 1;
		if(j==4)
			j = 0;
		xt1 = Point[i].x; yt1 = Point[i].y; zt1 = Point[i].z;
		xt2 = Point[j].x; yt2 = Point[j].y; zt2 = Point[j].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	for(  i=4; i<8; i++)
	{
		j = i + 1;
		if(j==8)
			j = 4;
		xt1 = Point[i].x; yt1 = Point[i].y; zt1 = Point[i].z;
		xt2 = Point[j].x; yt2 = Point[j].y; zt2 = Point[j].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	for( i=0; i<4; i++)
	{
		xt1 =   Point[i].x; yt1 =   Point[i].y; zt1 =   Point[i].z;
		xt2 = Point[i+4].x; yt2 = Point[i+4].y; zt2 = Point[i+4].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	for( i=0; i<2; i++)
	{
		xt1 =   Point[i].x; yt1 =   Point[i].y; zt1 =   Point[i].z;
		xt2 = Point[i+2].x; yt2 = Point[i+2].y; zt2 = Point[i+2].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}
}

//       
void LineLButtonUp(HWND hwnd)
{
	if(Dat.ButtonDown && Dat.Drawing)
	{
		Dat.Drawing = FALSE;
	}
	Dat.ButtonDown = FALSE;
}

