//B- 
//     3- 

#include <windows.h>     
#include "resource.h"     

#include <math.h>
#include <stdio.h>

// 
HINSTANCE hInstApp;



//  
int    Npoints;

// 
int    Ndegree;

//    Knodel = Npoints + Ndegree
int    Knodal;

//  
double t_0;

//  
double t_N;

//   t
double t_min, t_max;

//    
int    flagOpen;			 


//     x   y 
const int N = 201;
double corX[N], corY[N];



//  
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
BOOL CALLBACK DialProc(HWND, UINT, WPARAM, LPARAM);

void SplineDC(HWND);
void SplineLButtonDown();
void SplineLButtonUp();
void SplineCreate(HWND hWnd);
void SplineMouseMove( HWND hWnd, int x, int y);
void LineDC(HWND hwnd);


int WINAPI WinMain(HINSTANCE hInstance,       // 
				   HINSTANCE hPrevInstance,
				   LPSTR     lpCmdParam, 
				   int       nCmdShow)     
{

	char cname[] = "Spline";     //    
	char title[] = "  B-spline Curves  (Nodal Vector, Normalized Basic Functions)";  //  
	
	MSG msg;    //     
	
	//   
	//------------------------------------------------------------------------
	WNDCLASS wc;  //      

	wc.style          = 0; 
	wc.lpfnWndProc    = (WNDPROC)WndProc;         //  
	wc.cbClsExtra     = 0;       
	wc.cbWndExtra     = 0;       
	wc.hInstance      = hInstance;       // 
	wc.hIcon          = LoadIcon(hInstance, (LPCTSTR)IDI_APPLICATION); 
	wc.hCursor		  = LoadCursor(NULL, IDC_ARROW);  
	wc.hbrBackground  = (HBRUSH)GetStockObject(LTGRAY_BRUSH);   
	wc.lpszMenuName   = (LPCTSTR)MENU1;       
	wc.lpszClassName  = cname;      

	if(!RegisterClass(&wc))  //   
		return 0;

	hInstApp = hInstance;

	//  
	//------------------------------------------------------------------------
	 HWND hWnd;       //   

	 hWnd = CreateWindow(cname,
						 title,
						 WS_OVERLAPPEDWINDOW,
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 CW_USEDEFAULT, 
						 NULL,         // -     
						 NULL,          //   
						 hInstance,     // 
						 NULL);         

	if(!hWnd)
		return 0;



	//  .     ShowWindow,
    //   ,   UpdateWindows,
    //   WM_PAINT   
 	//--------------------------------------------------------------------------
	ShowWindow(hWnd,nCmdShow);
	UpdateWindow(hWnd); 


	//    
	//-------------------------------------------------------------------------
  
	while(GetMessage(&msg,NULL,0,0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return 0;


}

// ,  
LRESULT CALLBACK  WndProc(HWND hWnd, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
	// 
	int x, y;
	//     
	int EndDial;
	switch(message)
	{
		//   
		case WM_CREATE:
			SplineCreate(hWnd);  //   
			break;

			//     
		case WM_LBUTTONDOWN:
				SplineLButtonDown();
			break;

		//     
		case WM_LBUTTONUP:
				SplineLButtonUp();
			break;

		//   
		case WM_MOUSEMOVE:
				x = LOWORD(lParam);
				y = HIWORD(lParam);
				SplineMouseMove(hWnd,x,y);
			break;

		//   
		case WM_DESTROY:
			PostQuitMessage(0);  //   
			break;
		
		//   
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case ID_EXIT:
					PostQuitMessage(0);  //   
					break;

				case ID_CLEAN:
					InvalidateRect(hWnd, NULL, TRUE);  //  WM_PAINT
					break;

				case ID_UNIFORM_CUBIC_SPLINE:
					flagOpen = 0;
					Npoints = 4;
					Ndegree = 3;
					t_0 = -3.0;
					t_min = 0.0;
					t_max = 1.0;
					SplineDC(hWnd);
					break;

				case ID_OPEN_CUBIC_SPLINE:
					flagOpen = 1;
					Npoints = 4;
					Ndegree = 3;
					t_0 = 0.0;
					t_min = 0.0;
					t_max = 0.999;
					SplineDC(hWnd);
					break;

				case ID_UNIFORM_ARBITRARY_SPLINE:
					flagOpen = 0;
					EndDial = DialogBox(hInstApp, (LPCTSTR)IDD_DIALOG1, hWnd, DialProc);
		//  . 1-  -   
					//             2-  -     
					//             3-  -   
					//             4-  -    
					
					if(EndDial)
						SplineDC(hWnd);
					break;

				case ID_OPEN_ARBITRARY_SPLINE:
					flagOpen = 1;
					EndDial = DialogBox(hInstApp, (LPCTSTR)IDD_DIALOG1, hWnd, DialProc);
		//  . 1-  -   
					//             2-  -     
					//             3-  -   
					//             4-  -    
					
					if(EndDial)
						SplineDC(hWnd);
					break;

			}
			break;

		default:
			return DefWindowProc(hWnd,message,wParam,lParam);
	}

	return 0;

}


//  
BOOL CALLBACK DialProc(HWND hwndDlg, UINT uMsg,
	                      WPARAM wParam, LPARAM lParam)
{
	char S[10];
	switch(uMsg)
	{
		//    
		case WM_INITDIALOG:
			sprintf(S,"%d",4);
			SetWindowText(GetDlgItem(hwndDlg, IDC_EDIT1), S);
			sprintf(S,"%d",3);
			SetWindowText(GetDlgItem(hwndDlg, IDC_EDIT2), S);
			if(flagOpen == 1)
				sprintf(S,"%3.1f",0.0);
			else
				sprintf(S,"%3.1f",-3.0);
			SetWindowText(GetDlgItem(hwndDlg, IDC_EDIT3), S);
			sprintf(S,"%3.1f",0.0);
			SetWindowText(GetDlgItem(hwndDlg, IDC_EDIT4), S);
			sprintf(S,"%5.3f",0.999);
			SetWindowText(GetDlgItem(hwndDlg, IDC_EDIT5), S);
			break;

		//    
		case WM_CLOSE:
			EndDialog(hwndDlg, 0);
			break;

		//,     
		case WM_COMMAND:
			if(LOWORD(wParam) == IDCANCEL)  // 
			{
				EndDialog(hwndDlg, 0);
			}
			if(LOWORD(wParam) == IDOK)  // 
			{
				GetWindowText(GetDlgItem(hwndDlg, IDC_EDIT1), S, 10);
				Npoints = atoi(S);
				GetWindowText(GetDlgItem(hwndDlg, IDC_EDIT2), S, 10);
				Ndegree = atoi(S);
				GetWindowText(GetDlgItem(hwndDlg, IDC_EDIT3), S, 10);
				t_0 = atof(S);
				GetWindowText(GetDlgItem(hwndDlg, IDC_EDIT4), S, 10);
				t_min = atof(S);
				GetWindowText(GetDlgItem(hwndDlg, IDC_EDIT5), S, 10);
				t_max = atof(S);

				EndDialog(hwndDlg, 1);
			}
			break;
	}
	return 0;
}






struct POINT2 {
	double x, y;
};

//  
POINT2 V[31];

//    
double tv[41];






//      
double xLeft, xRight, yBottom, yTop;
//       
int    nLeft, nRight, mBottom, mTop;

//
int flagDown, flagUp, flagLock;
//   
int Nlock;


//  x   n
inline int xn(double x)
{
	return (int)((x - xLeft)/(xRight - xLeft)*(nRight - nLeft)) + nLeft;
}

//  y   m
inline int ym(double y)
{
	return (int)((y - yBottom)/(yTop - yBottom)*(mTop - mBottom)) + mBottom;
}



//  B-
double Nbase(int m, int i, double t)
{
	if(m == 0)
	{
		if(tv[i]<=t && t<tv[i+1])
			return 1;
		else
			return 0;
	}

	double a,b,f1,f2;
	a = Nbase(m-1, i, t); b = Nbase(m-1,i+1,t);
	if(a == 0)
		f1 = 0;
	else
		f1 = (t-tv[i])*a/(tv[i+m]-tv[i]);

	if(b == 0)
		f2 = 0;
	else
		f2 = (tv[i+m+1]-t)*b/(tv[i+m+1]-tv[i+1]);

	return f1 + f2;
}

//   
POINT2 BsplineBase(int N, int m, double t)
{
  POINT2 S;
  S.x = 0; S.y = 0;
  for(int i=0; i<N; i++)
  {
	double Nbas =  Nbase(m,i,t);
	 S.x += V[i].x*Nbas;
	 S.y += V[i].y*Nbas;
  }
  return S;
}


//  WM_LBUTTONDOWN
void SplineLButtonDown()
{
	flagUp   = 0;
	flagDown = 1;
}

//  WM_LBUTTONUP
void SplineLButtonUp()
{
	flagUp   = 1;
	flagDown = 0;
	flagLock = 0;
}



//  WM_CREATE
void SplineCreate(HWND hWnd)
{
	flagOpen = 0;
	flagDown = 0; flagUp = 0; flagLock = 0;
}


//   n  x 
inline double nx(int n)
{
	return (n - nLeft)*(xRight - xLeft)/(nRight - nLeft) + xLeft;
}

//   m  y 
inline double my(int m)
{
	return (m - mBottom)*(yTop - yBottom)/(mTop - mBottom) + yBottom;
}


void SplineMouseMove(HWND hwnd,int x, int y)
{
	if(flagDown)
	{
		if(!flagLock)
			for(int i=0; i<Npoints; i++)
				if(abs(x-xn(V[i].x))+abs(y-ym(V[i].y))<10)
				{
					Nlock = i;
					flagLock = 1;
				}
		if(flagLock)
		{
			V[Nlock].x = nx(x);  V[Nlock].y = my(y);
			LineDC(hwnd);
		}
	}
}





//    
void SplineDC(HWND hwnd)
{

	
	RECT rc;
	GetClientRect(hwnd,&rc); //     <hwnd>

	//       
	xLeft = -10; xRight =  10; yBottom =  -6; yTop =  6;
	nLeft = rc.left; nRight = rc.right; mBottom = rc.bottom; mTop = rc.top;


//       
	double kr = 0.75;
	for(int i=0; i<Npoints; i++)
	{
		V[i].x = kr*(xLeft + rand()*(xRight - xLeft)/RAND_MAX);
		V[i].y = kr*(yBottom + rand()*(yTop - yBottom)/RAND_MAX);
	}

	Knodal = Npoints + Ndegree + 1;
//       B-
	if(flagOpen == 0)
		for(int nv=0; nv<Knodal; nv++)
			tv[nv] = t_0 + nv;

//        B-
	int e0, e1, e2;
	if(flagOpen == 1)
	{
		for(e0=0; e0<Ndegree; e0++)
			tv[e0] = 0;	
		for(e1=0; e1<Knodal - 2*Ndegree; e1++)
			tv[Ndegree + e1] = e1;	
		for(e2=0; e2<Ndegree; e2++)
			tv[Knodal - Ndegree + e2] = e1-1;	
	}

	t_N = tv[Knodal-1];

	LineDC( hwnd);


}


//    B-
void Line_Functions(HWND hwnd, HDC hdc)
{

	//      
	double xLeftOld, xRightOld, yBottomOld, yTopOld;
	//       
	int    nLeftOld, nRightOld, mBottomOld, mTopOld;

	//    
	xLeftOld = xLeft, xRightOld = xRight, yBottomOld = yBottom, yTopOld = yTop;
	nLeftOld = nLeft, nRightOld = nRight, mBottomOld = mBottom, mTopOld = mTop;
	

	RECT rc;
	GetClientRect(hwnd,&rc); //     <hwnd>

	//       
	nLeft = rc.right - (rc.right - rc.left)/3; nRight = rc.right-5; 
	mBottom = rc.top + (rc.bottom - rc.top)/3 + 20; mTop = rc.top+25;

	xLeft = t_0 - 1; xRight =  t_N + 1; yBottom =  -0.3; yTop =  1.3;



	HBRUSH hbrush = CreateSolidBrush(RGB(0xC0,0xC0,0xC0));
	HBRUSH hbrushOld = (HBRUSH)SelectObject(hdc,hbrush); 

	HPEN hpen1 = CreatePen(PS_SOLID,3,RGB(100,100,255));
	HPEN hpenOld = (HPEN)SelectObject(hdc,hpen1);    

	Rectangle(hdc,nLeft,mBottom,nRight,mTop);
	int nb, ne, mb, me;
	POINT  pt;

	HPEN hpen4 = CreatePen(PS_SOLID,1,RGB(150,150,150));
	SelectObject(hdc,hpen4);    	//  <hpen2>    <hdc>

	for(int kk=0; kk<2; kk++)
	{
	//  
 	nb = xn(xLeft); mb = ym(kk);
	MoveToEx(hdc, nb, mb, &pt);
	ne = xn(xRight); me = ym(kk);
	LineTo(hdc,ne,me);
	}
	
	for( double kd=t_0; kd<=t_N; kd += 1.0)
	{
	//  
	nb = xn(kd); mb = ym(yBottom);
	MoveToEx(hdc, nb, mb, &pt);
	ne = xn(kd); me = ym(yTop);
	LineTo(hdc,ne,me);
	}


	//  <hpen2>,  - ,  1 ,  - -
	HPEN hpen2 = CreatePen(PS_SOLID,1,RGB(0,255,255));
	SelectObject(hdc,hpen2);    	//  <hpen2>    <hdc>

		
	//  OX
 	nb = xn(xLeft); mb = ym(0);
	MoveToEx(hdc, nb, mb, &pt);
	ne = xn(xRight); me = ym(0);
	LineTo(hdc,ne,me);

	//  OY
	nb = xn(0); mb = ym(yBottom);
	MoveToEx(hdc, nb, mb, &pt);
	ne = xn(0); me = ym(yTop);
	LineTo(hdc,ne,me);


	//  <hpen2>,  - ,  1 ,  - -

	//  
	LOGFONT lf;

	memset(&lf, 0, sizeof(LOGFONT)); 
	strcpy(lf.lfFaceName, "Ariel");
	lf.lfHeight = -(mBottom - mTop)/14;

	HFONT hFont = CreateFontIndirect(&lf);
	HFONT hFontOld = (HFONT)SelectObject(hdc, hFont);

	//        ym
	TEXTMETRIC lptxt;
	GetTextMetrics(hdc, &lptxt);
	int nWidth = lptxt.tmAveCharWidth;
	int nHeight = lptxt.tmHeight;

	//   
//	SetTextColor(hdc,RGB(255,255,255));
	SetBkColor(hdc,RGB(0xC0,0xC0,0xC0));
	TextOut(hdc,xn((xLeft+xRight)/2), ym(1)+3, "N(t)",4);
//	TextOut(hdc,nLeft+220, mBottom-40, "t",1);
	TextOut(hdc,xn(xRight) - 2*nWidth,ym(0) - nHeight,"t",1);

	//   
	char ss[10];
	sprintf(ss,"%4.1f",xLeft);
	TextOut(hdc,xn(xLeft)+2,ym(0)+2,ss,4);
	sprintf(ss,"%4.1f",xRight);
	TextOut(hdc, xn(xRight) - 4*nWidth,ym(0)+2,ss,4);
	TextOut(hdc, xn(0) + 2, ym(1) - nHeight,"1.0",3);



	//    


	double x, y, dx = (t_N - t_0)/(N-1);

	HPEN hpen3;
	for(int kv=0; kv<Npoints; kv++)
	{
		hpen3 = CreatePen(PS_SOLID,2,RGB(255,100+155*kv/Npoints,0));
		SelectObject(hdc,hpen3);

		for(int i=0; i<N; i++)
		{
			x = t_0 + dx*i; y = Nbase(Ndegree,kv,x);
			corX[i] = x; corY[i] = y;
		}

		nb = xn(corX[0]);  mb = ym(corY[0]);
		MoveToEx(hdc, nb, mb, &pt);
		for( i=1; i<N; i++)
		{
			nb = xn(corX[i]);  mb = ym(corY[i]);
			LineTo(hdc,nb,mb);
		}
		DeleteObject(hpen3);         //  <hpen3>
	}
	
	SelectObject(hdc,hbrushOld); //   <hbrushOld>    <hdc>
	DeleteObject(hbrush);        //  <hbrush>

	SelectObject(hdc,hpenOld);   //   <hpenOld>    <hdc>
	DeleteObject(hpen1);         //  <hpen1>
	DeleteObject(hpen2);         //  <hpen2>
//	DeleteObject(hpen3);         //  <hpen3>
	DeleteObject(hpen4);         //  <hpen3>

	SelectObject(hdc, hFontOld); //   <hFontOld>    <hdc>
	DeleteObject(hFont);         //  <hFont> 


//	EndPaint(hwnd, &ps);        //   <hdc>   <hwnd>

	//    
	xLeft = xLeftOld, xRight = xRightOld, yBottom = yBottomOld, yTop = yTopOld;
	nLeft = nLeftOld, nRight = nRightOld, mBottom = mBottomOld, mTop = mTopOld;



}










void LineDC(HWND hwnd)
{
	HDC hdc = GetDC(hwnd);  //   <hdc>   <hwnd>

	//   hdcMem,     hdc
	HDC hdcMem = CreateCompatibleDC(hdc);
	// ()      
	HBITMAP hBmp = CreateCompatibleBitmap(hdc, nRight, mBottom); 
	//   hBmp    hdcMem
	HBITMAP hBmpOld = (HBITMAP)SelectObject(hdcMem, hBmp); 

	HPEN hpen0 = CreatePen(PS_SOLID,2,RGB(0xC0,0xC0,0xC0));
	HPEN hpenOld = (HPEN)SelectObject(hdcMem,hpen0);    
	HBRUSH hbrush0 = CreateSolidBrush(RGB(0xC0,0xC0,0xC0));
	HBRUSH hbrushOld = (HBRUSH)SelectObject(hdcMem,hbrush0); 

	Rectangle(hdcMem,0,0,nRight,mBottom);


	//    B-
	Line_Functions(hwnd, hdcMem);


	HPEN hpen1 = CreatePen(PS_SOLID,2,RGB(0,255,255));
	SelectObject(hdcMem,hpen1);    

	int nb, mb, ne, me;
	//  OX
 	nb = xn(xLeft); mb = ym(0);
	MoveToEx(hdcMem, nb, mb, NULL);
	ne = xn(xRight); me = ym(0);
	LineTo(hdcMem,ne,me);

	//  OY
	nb = xn(0); mb = ym(yBottom);
	MoveToEx(hdcMem, nb, mb, NULL);
	ne = xn(0); me = ym(yTop);
	LineTo(hdcMem,ne,me);


	char str[200] = "";
	char ss[10];
	strcat(str,"[");
	for(int is=0; is<Knodal; is++)
	{
		sprintf(ss,"%3d",int(tv[is]));
		strcat(str,ss);
	}
	strcat(str," ]");

	SetBkColor(hdcMem,RGB(0xC0,0xC0,0xC0));
	SetTextColor(hdcMem,RGB(0,0,0x80));
	TextOut(hdcMem,nLeft+10, 5, "Nodal Vector",12);
	TextOut(hdcMem,nLeft+5, 20, str,3*Knodal+3);
	
	TextOut(hdcMem,nRight-190, 5, "Normalized Basic Functions",26);

	TextOut(hdcMem,nLeft+10, mBottom-35, "Parameter t",11);
	sprintf(ss,"%6.3f",t_min);
	TextOut(hdcMem,nLeft+5, mBottom-20, ss,6);
	TextOut(hdcMem,nLeft+45, mBottom-20, "  <  t  <  ",11);
	sprintf(ss,"%6.3f",t_max);
	TextOut(hdcMem,nLeft+95, mBottom-20, ss,6);



	HPEN hpen2 = CreatePen(PS_SOLID,2,RGB(255,255,255));
	SelectObject(hdcMem,hpen2);    
//     
	MoveToEx(hdcMem,xn(V[0].x),ym(V[0].y),0);
	for( int i=1; i<Npoints; i++)
		LineTo(hdcMem,xn(V[i].x),ym(V[i].y));

	HPEN hpen3 = CreatePen(PS_SOLID,2,RGB(0,255,0));
	SelectObject(hdcMem,hpen3);    

//  B-
		int Nt = 25*Npoints;
		double t, dt = (t_max - t_min)/(Nt-1);
		MoveToEx(hdcMem,xn(BsplineBase(Npoints,Ndegree,t_min).x),ym(BsplineBase(Npoints,Ndegree,t_min).y),0);
		for(int p=1; p<Nt; p++)
		{
			t = t_min + dt*p;
//			if(t == t_max)
//				t = t_max - 0.0001;
			LineTo(hdcMem,xn(BsplineBase(Npoints,Ndegree,t).x),ym(BsplineBase(Npoints,Ndegree,t).y));
		}


	HPEN hpen4 = CreatePen(PS_SOLID,1,RGB(0,255,255));
	SelectObject(hdcMem,hpen4);    
	HBRUSH hbrush = CreateSolidBrush(RGB(255,0,0));
	SelectObject(hdcMem,hbrush); 
//     
	for(i=0; i<Npoints; i++)
	{
		int x1, y1;
		x1 = xn(V[i].x); y1 = ym(V[i].y);
		Ellipse(hdcMem, x1-4, y1-4, x1+4, y1+4);
		sprintf(ss,"V%d",i);
		if(i<10)
		TextOut(hdcMem,x1-20-2*i, y1-10+1*i, ss,2);
		else
		TextOut(hdcMem,x1-20-2*i, y1-10+1*i, ss,3);
	}
	
	

//     
	BitBlt(hdc, 0, 0, nRight, mBottom, hdcMem, 0, 0, SRCCOPY);

	SelectObject(hdcMem,hbrushOld); 
	DeleteObject(hbrush0);        
	DeleteObject(hbrush);        

	SelectObject(hdcMem,hpenOld);   
	DeleteObject(hpen0);         
	DeleteObject(hpen1);         
	DeleteObject(hpen2);         
	DeleteObject(hpen3);         
	DeleteObject(hpen4);         

	SelectObject(hdcMem,hBmpOld);   
	DeleteObject(hBmp);               

	DeleteDC(hdcMem);                 

	ReleaseDC(hwnd, hdc);  

}

