//    ()
//   


#define STRICT
#include <windows.h>
#include <math.h>
#include <stdio.h>


// 
char const szClassName[] = "LineClass";
// 
char const szWindowTitle[] = "Korneev V.        "
			"   Bezie-Spline  Jug,       "
			"   rotation  by  mouse  and  keyboard (arrows)";


struct TDATA {

	BOOL ButtonDown;
	BOOL Drawing;
};

static TDATA Dat;

struct ANGLS {
	double fi, teta;
};

static ANGLS angl,anglOld;

struct CORD {
	int x, y;
};

static CORD corOld;

struct POINT3 {
	double x, y, z;
};

static POINT3 Point[8];



// 
BOOL RegisterApp(HINSTANCE hInst);
HWND CreateApp(HINSTANCE, int);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void LineCreate();
void LineDestroy();
void LinePaint(HWND);
void LineDC(HWND);
void LineLButtonDown(int,int);
void LineMouseMove(HWND,int,int);
void DrawBox(HWND, HDC, ANGLS);
void LineLButtonUp();
void PointCorns();


//  -    
int WINAPI WinMain(HINSTANCE hInst,
						 HINSTANCE hPrevInstance,
						 LPSTR     lpszCmdParam,
						 int       nCmdShow)
{
	MSG msg;

	if(!RegisterApp(hInst))  // 
		return FALSE;

	if(!CreateApp(hInst,nCmdShow))  // 
		return FALSE;

	while(GetMessage(&msg,NULL,0,0))   //  
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}

// 
BOOL RegisterApp(HINSTANCE hInst)
{
	WNDCLASS wc;

	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInst;
	wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor		  = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH)GetStockObject(GRAY_BRUSH);
	wc.lpszClassName = szClassName;

	return RegisterClass(&wc);
}



//  
HWND CreateApp(HINSTANCE hInstance, int nCmdShow)
{
	 HWND hwnd;

	 hwnd = CreateWindow(szClassName,
									 szWindowTitle,
									 WS_OVERLAPPEDWINDOW,
                            100, //x -  .. 
                            50,  //y -  .. 
                            650, // 
                            500, // 
									 NULL,
									 NULL,
									 hInstance,
									 NULL);

	if(hwnd == NULL)
		return hwnd;

	ShowWindow(hwnd,nCmdShow);
	UpdateWindow(hwnd);

	return hwnd;
}







//   
LRESULT CALLBACK  WndProc(HWND hwnd, UINT msg,
											WPARAM wParam, LPARAM lParam)
{

	int x,y;
	switch(msg)
	{
		case WM_CREATE:
			LineCreate();
			break;

		case WM_PAINT:
			LinePaint(hwnd);
			break;

		case WM_LBUTTONDOWN:
				x = LOWORD(lParam);
				y = HIWORD(lParam);
				LineLButtonDown(x,y);
			break;

		case WM_LBUTTONUP:
				LineLButtonUp();
					LineDC(hwnd);
//				InvalidateRect(hwnd,NULL,TRUE);
			break;


		case WM_MOUSEMOVE:
				x = LOWORD(lParam);
				y = HIWORD(lParam);

				LineMouseMove( hwnd,x,y);
					LineDC(hwnd);
			break;

		case WM_KEYDOWN:
			switch(wParam)
			{
				case VK_LEFT:
					angl.fi += 10;
					LineDC(hwnd);
//					InvalidateRect(hwnd,NULL,TRUE);
					break;

				case VK_RIGHT:
					angl.fi -= 10;
					LineDC(hwnd);
//					InvalidateRect(hwnd,NULL,TRUE);
					break;

				case VK_UP:
					angl.teta += 10;
					LineDC(hwnd);
//					InvalidateRect(hwnd,NULL,TRUE);
					break;

				case VK_DOWN:
					angl.teta -= 10;
					LineDC(hwnd);
//					InvalidateRect(hwnd,NULL,TRUE);
					break;
			}
			break;

		case WM_DESTROY:
			LineDestroy();
			break;

		default:
			return DefWindowProc(hwnd,msg,wParam,lParam);
	}

	return 0L;
}



// 
//  B-  Nelm x Melm
const int Nelm = 3, Melm = 6;  
//   Np x Mp
const int Np = 3*Nelm + 1, Mp = 3*Melm + 1;

//  
double Ppx[Np][Mp], Ppy[Np][Mp], Ppz[Np][Mp];

 //        
double xe1, xe2, ye1, ye2;
int    ne1, ne2, me1, me2;

// 
//    -  
  double xmax, ymax, zmax;


//,     
const int Ntext = 100;
// 
double ut[Ntext], vt[Ntext];


//    
//#pragma argsused
void LineCreate()
{
//        
	xe1 = -3;  xe2 =   3; ye1 =  -3; ye2 =  3;
	ne1 = 175; ne2 = 475; me1 = 375; me2 = 75;


//    -  
	xmax=2, ymax=2., zmax=2.;

	PointCorns();

//    -  
	angl.fi = 30; angl.teta = 60;



	double R;

//   Z
	double zbeg = -2,  zend = 2;

//   phsi
	double phbeg = 0, phend = 360;


//      
// 
//   ( 0.2 + 0.7*z + 0.7*sin(2.5*z))^2 = x^2 + y^2
//     
//   : z, phsi

//  x =R * cos(phsi)
//  y =R * sin(phsi)
// 	R = 0.2 + 0.7*z + 0.7*sin(2.5*z); 



	double z, x, y, phsi, dz, dp;

//        
   dz = (zend - zbeg)/(Np-1);
   dp = (phend - phbeg)/(Mp-1);

   for(int n = 0; n < Np; n++)
   {
   	z = zbeg + dz*n;
	R = 0.2 + 0.7*(z+2) + 0.7*sin(1.5*(z+2)); 
	for(int m = 0; m < Mp; m++)
      {
      	phsi = phbeg + dp*m;
         x = R*cos(3.14159/180*phsi);
         y = R*sin(3.14159/180*phsi);

      	Ppx[n][m] = x;
      	Ppy[n][m] = y;
         Ppz[n][m] = z;
      }
   }




//      
// ,     -
//     .

/*   
   for( n = 1; n < Np-1; n++)
   {
		Ppx[n][Mp-2] =  Ppx[n][1];
		Ppy[n][Mp-2] =  Ppy[n][1];
		Ppz[n][Mp-2] =  Ppz[n][1];

		Ppx[n][0] =  Ppx[n][Mp-3];
		Ppy[n][0] =  Ppy[n][Mp-3];
		Ppz[n][0] =  Ppz[n][Mp-3];

		Ppx[n][Mp-1] = Ppx[n][2];
		Ppy[n][Mp-1] = Ppy[n][2];
		Ppz[n][Mp-1] = Ppz[n][2];


  
  }


   for(int m = 0; m < Mp; m++)
   {
		Ppx[0][m] = 2*Ppx[1][m] - Ppx[2][m];
		Ppy[0][m] = 2*Ppy[1][m] - Ppy[2][m];
		Ppz[0][m] = 2*Ppz[1][m] - Ppz[2][m];

		Ppx[Np-1][m] = 2*Ppx[Np-2][m] - Ppx[Np-3][m];
		Ppy[Np-1][m] = 2*Ppy[Np-2][m] - Ppy[Np-3][m];
		Ppz[Np-1][m] = 2*Ppz[Np-2][m] - Ppz[Np-3][m];
   }
*/

//    
	double ro, t, dt = 6.28/(Ntext-1);
   for(int i=0; i<Ntext; i++)
   {
   	t = dt*i;
      ro = 0.5*cos(4.*t)*cos(4.*t);
      ut[i] = ro*cos(t)+0.5;
      vt[i] = ro*sin(t)+0.5;
   }


}

//   -    
void	PointCorns()
{
	Point[0].x =  xmax; Point[0].y =  ymax; Point[0].z = -zmax;
	Point[1].x = -xmax; Point[1].y =  ymax; Point[1].z = -zmax;
	Point[2].x = -xmax; Point[2].y = -ymax; Point[2].z = -zmax;
	Point[3].x =  xmax; Point[3].y = -ymax; Point[3].z = -zmax;
	Point[4].x =  xmax; Point[4].y =  ymax; Point[4].z = zmax;
	Point[5].x = -xmax; Point[5].y =  ymax; Point[5].z = zmax;
	Point[6].x = -xmax; Point[6].y = -ymax; Point[6].z = zmax;
	Point[7].x =  xmax; Point[7].y = -ymax; Point[7].z = zmax;
}

//#pragma argsused
void LineDestroy()
{
	PostQuitMessage(0);   // 
}

//  -  
double sf,cf,st,ct;


//  
double Bezie(int i, double t)
{
	double b;
	switch(i)
	{
	  case 0  : b=(1-t)*(1-t)*(1-t); break;
	  case 1  : b=3*t*(1-t)*(1-t);   break;
	  case 2  : b=3*t*t*(1-t);       break;
	  case 3  : b=t*t*t;             break;
	}
	return b;
}


// - 
double Bspl(int i, double t)
{
	double b;
	double t2 = t*t, t3 = t2*t;
	switch(i)
	{
	case 0:  b = (1 - 3*t + 3*t2 -   t3)/6; break;
	case 1:  b = (4       - 6*t2 + 3*t3)/6; break;
	case 2:  b = (1 + 3*t + 3*t2 - 3*t3)/6; break;
	case 3:  b =                     t3/6;  break;
	}
	return b;
}


// 16-  
//  - 
double Pex[4][4], Pey[4][4], Pez[4][4];

/*
//X-    
double splinesX(double u,double v)
{
  double S1=0, S2;
  int i,j;
  for(i=0; i<4; i++)
  {
	 S2=0;
	 for(j=0; j<4; j++)
		S2 += Pex[i][j]*Bspl(j,v);
	 S1 += S2*Bspl(i,u);
  }
  return S1;
}


//Y-    
double splinesY(double u,double v)
{
  double S1=0, S2;
  int i,j;
  for(i=0; i<4; i++)
  {
	 S2=0;
	 for(j=0; j<4; j++)
		S2 += Pey[i][j]*Bspl(j,v);
	 S1 += S2*Bspl(i,u);
  }
  return S1;
}

//Y-    
double splinesZ(double u,double v)
{
  double S1=0, S2;
  int i,j;
  for(i=0; i<4; i++)
  {
	 S2=0;
	 for(j=0; j<4; j++)
		S2 += Pez[i][j]*Bspl(j,v);
	 S1 += S2*Bspl(i,u);
  }
  return S1;
}

*/

//X-    
double splinesX(double u,double v)
{
  double S1=0, S2;
  int i,j;
  for(i=0; i<4; i++)
  {
	 S2=0;
	 for(j=0; j<4; j++)
		S2 += Pex[i][j]*Bezie(j,v);
	 S1 += S2*Bezie(i,u);
  }
  return S1;
}


//Y-    
double splinesY(double u,double v)
{
  double S1=0, S2;
  int i,j;
  for(i=0; i<4; i++)
  {
	 S2=0;
	 for(j=0; j<4; j++)
		S2 += Pey[i][j]*Bezie(j,v);
	 S1 += S2*Bezie(i,u);
  }
  return S1;
}

//Z-    
double splinesZ(double u,double v)
{
  double S1=0, S2;
  int i,j;
  for(i=0; i<4; i++)
  {
	 S2=0;
	 for(j=0; j<4; j++)
		S2 += Pez[i][j]*Bezie(j,v);
	 S1 += S2*Bezie(i,u);
  }
  return S1;
}





//       
double Xe(double x,double y)
{
  return -sf*x+cf*y;
}

//       
double Ye(double x,double y,double z)
{
  return -ct*cf*x-ct*sf*y+st*z;
}

//     
//   x    n
inline int xn(double x)
{
	return (int)((x - xe1)/(xe2 - xe1)*(ne2 - ne1)) + ne1;
}

//   y    m
inline int ym(double y)
{
	return (int)((y - ye1)/(ye2 - ye1)*(me2 - me1)) + me1;
}


//    
void LinePaint(HWND hwnd)
{
	PAINTSTRUCT ps;

//    
	HDC hdcWin = BeginPaint(hwnd, &ps);

//    
	char strs[20];
	SetBkColor(hdcWin,RGB(128,128,128));
	SetTextColor(hdcWin,RGB(0xC0,0xC0,0xC0));

	TextOut(hdcWin,518,40," Surface  Number ",17);
	sprintf(strs,"Nelm = %2d",Nelm);
	TextOut(hdcWin,540,60,strs,9);
	sprintf(strs,"Melm = %2d",Melm);
	TextOut(hdcWin,540,80,strs,9);

	TextOut(hdcWin,500,120," Control Poin Number ",21);
	sprintf(strs,"  Np = %2d",Np);
	TextOut(hdcWin,540,140,strs,9);
	sprintf(strs,"  Mp = %2d",Mp);
	TextOut(hdcWin,540,160,strs,9);


	HDC hdc = CreateCompatibleDC(hdcWin); // 
                     //    

   //     -     
   //   .       
	HBITMAP hBitmap, hBitmapOld;
	hBitmap = CreateCompatibleBitmap(hdcWin, ne2, me1); //
               //     
	hBitmapOld = (HBITMAP)SelectObject(hdc, hBitmap); //
                //     



//      
	HRGN hrgn1 = CreateRectRgn(ne1,me2-30,ne2,me2-2);

//    
	HBRUSH hBrush0 = CreateSolidBrush(RGB(0xA6,0xCA,0xF0));
   FillRgn(hdc,hrgn1,hBrush0);

//    
	HBRUSH hBrush1 = CreateSolidBrush(RGB(0xFF,0xFF,0xC0));
	FrameRgn(hdc,hrgn1,hBrush1,2,2);

//      hrgn1
   char ss[10];
	SetBkColor(hdc,RGB(0xA6,0xCA,0xF0));
	SetTextColor(hdc,RGB(0,0,0x80));
   sprintf(ss,"fi = %4.0lf",angl.fi);
   TextOut(hdc,(ne1+ne2)/2-80,me2-25,ss,9);
   sprintf(ss,"teta = %4.0lf",angl.teta);
   TextOut(hdc,(ne1+ne2)/2+20,me2-25,ss,11);

//  hrgn1
	DeleteObject(hrgn1); 



//  
	HRGN hrgn2 = CreateRectRgn(ne1,me2,ne2,me1);

//    
	HBRUSH hBrush2 = CreateSolidBrush(RGB(0xC0,0xC0,0xC0));
   FillRgn(hdc,hrgn2,hBrush2);


//   
	SelectClipRgn(hdc,hrgn2);

//       
	sf=sin(3.14159*angl.fi/180);
	cf=cos(3.14159*angl.fi/180);
	st=sin(3.14159*angl.teta/180);
	ct=cos(3.14159*angl.teta/180);

//    
	HPEN hPen1, hPenOld;
	hPen1 = CreatePen(PS_SOLID,1,RGB(0,255,255));
	hPenOld = (HPEN)SelectObject(hdc,hPen1);

//      
  double xe, ye;
// 
	int x1,y1,x2,y2;

//  Ox
	xe=Xe(-xmax/3,0);
	ye=Ye(-xmax/3,0,0);
	x1=xn(xe);
	y1=ym(ye);             
	xe=Xe(1.5*xmax,0);
	ye=Ye(1.5*xmax,0,0);
	x2=xn(xe);
	y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

//     
	SetBkColor(hdc,RGB(0xC0,0xC0,0xC0));
	SetTextColor(hdc,RGB(120,120,120));
	TextOut(hdc,x2, y2, "X",1);
	

//  Oy
	xe=Xe(0,-ymax/3);
	ye=Ye(0,-ymax/3,0);
	x1=xn(xe);
	y1=ym(ye);
	xe=Xe(0,1.5*ymax);
	ye=Ye(0,1.5*ymax,0);
	x2=xn(xe);
	y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

	TextOut(hdc,x2, y2, "Y",1);

//  Oz
	xe=Xe(0,0);
	ye=Ye(0,0,-zmax/3);
	x1=xn(xe);
	y1=ym(ye);
	xe=Xe(0,0);
	ye=Ye(0,0,1.5*zmax);
	x2=xn(xe);
	y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

	TextOut(hdc,x2, y2, "Z",1);

// 
	double xt, yt, zt;

//     Pp[Np][Mp]
//  16   Pe[][]  
//- 

for(int nc=0; nc<(Np-1)/3; nc++)
	for(int mc=0; mc<(Mp-1)/3; mc++)
   {

   for(int n=0; n<4; n++)
   	for(int m=0; m<4; m++)
      {
      	Pex[n][m] = Ppx[n+3*nc][m+3*mc];
      	Pey[n][m] = Ppy[n+3*nc][m+3*mc];
      	Pez[n][m] = Ppz[n+3*nc][m+3*mc];

      }
	
/*	
	for(int nc=0; nc<Np-3; nc++)
		for(int mc=0; mc<Mp-3; mc++)
   	{

   		for(int n=0; n<4; n++)
   			for(int m=0; m<4; m++)
      		{
      			Pex[n][m] = Ppx[n+nc][m+mc];
      			Pey[n][m] = Ppy[n+nc][m+mc];
      			Pez[n][m] = Ppz[n+nc][m+mc];

      		}
*/
  
// -   
// ,   



	HPEN hPen4 = CreatePen(PS_SOLID,1,RGB(255-100*mc,255-100*nc,100*mc));
	SelectObject(hdc,hPen4);

//" "
			int Ns=10, Nsp = 2;
   		double v, u, du = 1.0/(Ns-1), dv = 1.0/(Nsp-1);


   		for (int i=0; i<Nsp; i++)
   		{
      		v = dv*i;
					u = 0;

					xt = splinesX(u,v);
					yt = splinesY(u,v);
					zt = splinesZ(u,v);

					xe = Xe(xt,yt);
					ye = Ye(xt,yt,zt);

					x1 = xn(xe);
					y1 = ym(ye);

               MoveToEx(hdc,x1,y1,0);

				for(int j=1; j<Ns; j++)
				{
					u = du*j;

					xt = splinesX(u,v);
					yt = splinesY(u,v);
					zt = splinesZ(u,v);

					xe = Xe(xt,yt);
					ye = Ye(xt,yt,zt);

					x1 = xn(xe);
					y1 = ym(ye);

					LineTo(hdc,x1,y1);
				}

    		}


//" "
			int Ms=10, Msp = 2;
   		dv = 1.0/(Ms-1); du = 1.0/(Msp-1);


   		for ( i=0; i<Msp; i++)
   		{
      		u = du*i;
					v = 0;

					xt = splinesX(u,v);
					yt = splinesY(u,v);
					zt = splinesZ(u,v);

					xe = Xe(xt,yt);
					ye = Ye(xt,yt,zt);

					x1 = xn(xe);
					y1 = ym(ye);

            	MoveToEx(hdc,x1,y1,0);

				for(int j=1; j<Ms; j++)
				{
					v = dv*j;

					xt = splinesX(u,v);
					yt = splinesY(u,v);
					zt = splinesZ(u,v);

					xe = Xe(xt,yt);
					ye = Ye(xt,yt,zt);

					x1 = xn(xe);
					y1 = ym(ye);

					LineTo(hdc,x1,y1);

				}
			}





//  ()      
					xt = splinesX(ut[0],vt[0]);
					yt = splinesY(ut[0],vt[0]);
					zt = splinesZ(ut[0],vt[0]);

					xe = Xe(xt,yt);
					ye = Ye(xt,yt,zt);

					x1 = xn(xe);
					y1 = ym(ye);

            	MoveToEx(hdc,x1,y1,0);

				for(int k=1; k<Ntext; k++)
				{

					xt = splinesX(ut[k],vt[k]);
					yt = splinesY(ut[k],vt[k]);
					zt = splinesZ(ut[k],vt[k]);

					xe = Xe(xt,yt);
					ye = Ye(xt,yt,zt);

					x1 = xn(xe);
					y1 = ym(ye);

					LineTo(hdc,x1,y1);

				}







		  DeleteObject(hPen4);

    }

//       
	HPEN hPen2 = CreatePen(PS_SOLID,1,RGB(255,255,255));
	SelectObject(hdc,hPen2);

// 
   for(int m = 0; m <Mp; m++)
   {
		xe = Xe(Ppx[1][m],Ppy[1][m]);
		ye = Ye(Ppx[1][m],Ppy[1][m],Ppz[1][m]);
		x1=xn(xe);
		y1=ym(ye);
		for(int k=1; k<Np; k++)
		{
			xe = Xe(Ppx[k][m],Ppy[k][m]);
			ye = Ye(Ppx[k][m],Ppy[k][m],Ppz[k][m]);
			x2 = xn(xe);
			y2 = ym(ye);
			MoveToEx(hdc,x1,y1,0);
			LineTo(hdc,x2,y2);

			x1 = x2; y1 = y2;
		}
	}

//  
   for(int k = 0; k <Np; k++)
   {
		xe = Xe(Ppx[k][1],Ppy[k][1]);
		ye = Ye(Ppx[k][1],Ppy[k][1],Ppz[k][1]);
		x1=xn(xe);
		y1=ym(ye);
		for(int m=1; m<Mp; m++)
		{
			xe = Xe(Ppx[k][m],Ppy[k][m]);
			ye = Ye(Ppx[k][m],Ppy[k][m],Ppz[k][m]);
			x2 = xn(xe);
			y2 = ym(ye);
			MoveToEx(hdc,x1,y1,0);
			LineTo(hdc,x2,y2);

			x1 = x2; y1 = y2;
		}
	}



//   
   HPEN hPen3;
	hPen3 = CreatePen(PS_SOLID,1,RGB(160,160,160));
	SelectObject(hdc,hPen3);

	DrawBox(hwnd, hdc, angl);

//    
	SelectObject(hdc,hPenOld);
//   
	DeleteObject(hPen1);
	DeleteObject(hPen2);
	DeleteObject(hPen3);
	DeleteObject(hBrush0);
	DeleteObject(hBrush1);
	DeleteObject(hBrush2);
	DeleteObject(hrgn2);

	BitBlt(hdcWin,ne1,me2-30,ne2,me1,hdc,ne1,me2-30,SRCCOPY); //-
   //     

	SelectObject(hdc, hBitmapOld); //  
	DeleteObject(hBitmap); //  
	DeleteDC(hdc);  //    



//  
	EndPaint(hwnd, &ps);
}



//    
void LineDC(HWND hwnd)
{
//	PAINTSTRUCT ps;

//    
//  
	HDC hdcWin = GetDC(hwnd);
//	HDC hdcWin = BeginPaint(hwnd, &ps);

	HDC hdc = CreateCompatibleDC(hdcWin); // 
                     //    

   //     -     
   //   .       
	HBITMAP hBitmap, hBitmapOld;
	hBitmap = CreateCompatibleBitmap(hdcWin, ne2, me1); //
               //     
	hBitmapOld = (HBITMAP)SelectObject(hdc, hBitmap); //
                //     



//      
	HRGN hrgn1 = CreateRectRgn(ne1,me2-30,ne2,me2-1);

//    
	HBRUSH hBrush0 = CreateSolidBrush(RGB(0xA6,0xCA,0xF0));
   FillRgn(hdc,hrgn1,hBrush0);

//    
	HBRUSH hBrush1 = CreateSolidBrush(RGB(0xFF,0xFF,0xC0));
	FrameRgn(hdc,hrgn1,hBrush1,2,2);

//      hrgn1
   char ss[10];
	SetBkColor(hdc,RGB(0xA6,0xCA,0xF0));
	SetTextColor(hdc,RGB(0,0,0x80));
   sprintf(ss,"fi = %4.0lf",angl.fi);
   TextOut(hdc,(ne1+ne2)/2-80,me2-25,ss,9);
   sprintf(ss,"teta = %4.0lf",angl.teta);
   TextOut(hdc,(ne1+ne2)/2+20,me2-25,ss,11);

//  hrgn1
	DeleteObject(hrgn1);



//  
	HRGN hrgn2 = CreateRectRgn(ne1,me2,ne2,me1);

//    
	HBRUSH hBrush2 = CreateSolidBrush(RGB(0xC0,0xC0,0xC0));
   FillRgn(hdc,hrgn2,hBrush2);


//   
	SelectClipRgn(hdc,hrgn2);

//       
	sf=sin(3.14159*angl.fi/180);
	cf=cos(3.14159*angl.fi/180);
	st=sin(3.14159*angl.teta/180);
	ct=cos(3.14159*angl.teta/180);

//    
	HPEN hPen1, hPenOld;
	hPen1 = CreatePen(PS_SOLID,1,RGB(0,255,255));
	hPenOld = (HPEN)SelectObject(hdc,hPen1);

//      
  double xe, ye;
// 
	int x1,y1,x2,y2;

//  Ox
	xe=Xe(-xmax/3,0);
	ye=Ye(-xmax/3,0,0);
	x1=xn(xe);
	y1=ym(ye);
	xe=Xe(1.5*xmax,0);
	ye=Ye(1.5*xmax,0,0);
	x2=xn(xe);
	y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

//     
	SetBkColor(hdc,RGB(0xC0,0xC0,0xC0));
	SetTextColor(hdc,RGB(120,120,120));
	TextOut(hdc,x2, y2, "X",1);

	

//  Oy
	xe=Xe(0,-ymax/3);
	ye=Ye(0,-ymax/3,0);
	x1=xn(xe);
	y1=ym(ye);
	xe=Xe(0,1.5*ymax);
	ye=Ye(0,1.5*ymax,0);
	x2=xn(xe);
	y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

	TextOut(hdc,x2, y2, "Y",1);

//  Oz
	xe=Xe(0,0);
	ye=Ye(0,0,-zmax/3);
	x1=xn(xe);
	y1=ym(ye);
	xe=Xe(0,0);
	ye=Ye(0,0,1.5*zmax);
	x2=xn(xe);
	y2=ym(ye);
	MoveToEx(hdc,x1,y1,0);
	LineTo(hdc,x2,y2);

	TextOut(hdc,x2, y2, "Z",1);

/*
	HBRUSH hbrushX = CreateSolidBrush(RGB(255,100,100));
	HBRUSH hbrushOldX = (HBRUSH)SelectObject(hdc,hbrushX);     //  hbrush
	HPEN hpenX = CreatePen(PS_SOLID,1,RGB(255,100,100));
	HPEN hpenOldX = (HPEN)SelectObject(hdc,hpenX);         //   hpen
	
	xe=Xe(xmax,0);
	ye=Ye(xmax,0,0);
	x1=xn(xe);
	y1=ym(ye);             
	
	Ellipse(hdc, x1-4, y1-4,x1+4, y1+4 );

	char sss[10];
	sprintf(sss,"%2.4f",xmax);
	TextOut(hdc,x1-5,y1+5,sss,3);

	xe=Xe(0,ymax);
	ye=Ye(0,ymax,0);
	x1=xn(xe);
	y1=ym(ye);             
	
	Ellipse(hdc, x1-4, y1-4,x1+4, y1+4 );

	sprintf(sss,"%2.4f",ymax);
	TextOut(hdc,x1-5,y1+5,sss,3);
	
	xe=Xe(0,0);
	ye=Ye(0,0,zmax);
	x1=xn(xe);
	y1=ym(ye);             
	
	Ellipse(hdc, x1-4, y1-4,x1+4, y1+4 );

	sprintf(sss,"%2.4f",zmax);
	TextOut(hdc,x1-5,y1+5,sss,3);


	SelectObject(hdc,hbrushOldX);
	DeleteObject(hbrushX);
	SelectObject(hdc,hpenOldX);
	DeleteObject(hpenX);

*/



// 
	double xt, yt, zt;

//     Pp[Np][Mp]
//  16   Pe[][]  
//- 


for(int nc=0; nc<(Np-1)/3; nc++)
	for(int mc=0; mc<(Mp-1)/3; mc++)
   {

   for(int n=0; n<4; n++)
   	for(int m=0; m<4; m++)
      {
      	Pex[n][m] = Ppx[n+3*nc][m+3*mc];
      	Pey[n][m] = Ppy[n+3*nc][m+3*mc];
      	Pez[n][m] = Ppz[n+3*nc][m+3*mc];

      }

/*	
	for(int nc=0; nc<Np-3; nc++)
		for(int mc=0; mc<Mp-3; mc++)
   	{

   		for(int n=0; n<4; n++)
   			for(int m=0; m<4; m++)
      		{
      			Pex[n][m] = Ppx[n+nc][m+mc];
      			Pey[n][m] = Ppy[n+nc][m+mc];
      			Pez[n][m] = Ppz[n+nc][m+mc];

      		}

*/  
	
// -   
// ,   



	HPEN hPen4 = CreatePen(PS_SOLID,1,RGB(255-80*mc,255-80*nc,80*mc));
	SelectObject(hdc,hPen4);


	
	
//" "
			int Ns=10, Nsp = 2;
   		double v, u, du = 1.0/(Ns-1), dv = 1.0/(Nsp-1);


   		for (int i=0; i<Nsp; i++)
   		{
      		v = dv*i;
					u = 0;

					xt = splinesX(u,v);
					yt = splinesY(u,v);
					zt = splinesZ(u,v);

					xe = Xe(xt,yt);
					ye = Ye(xt,yt,zt);

					x1 = xn(xe);
					y1 = ym(ye);

               MoveToEx(hdc,x1,y1,0);

				for(int j=1; j<Ns; j++)
				{
					u = du*j;

					xt = splinesX(u,v);
					yt = splinesY(u,v);
					zt = splinesZ(u,v);

					xe = Xe(xt,yt);
					ye = Ye(xt,yt,zt);

					x1 = xn(xe);
					y1 = ym(ye);

					LineTo(hdc,x1,y1);
				}

    		}


//" "
			int Ms=10, Msp = 2;
   		dv = 1.0/(Ms-1); du = 1.0/(Msp-1);


   		for ( i=0; i<Msp; i++)
   		{
      		u = du*i;
					v = 0;

					xt = splinesX(u,v);
					yt = splinesY(u,v);
					zt = splinesZ(u,v);

					xe = Xe(xt,yt);
					ye = Ye(xt,yt,zt);

					x1 = xn(xe);
					y1 = ym(ye);

            	MoveToEx(hdc,x1,y1,0);

				for(int j=1; j<Ms; j++)
				{
					v = dv*j;

					xt = splinesX(u,v);
					yt = splinesY(u,v);
					zt = splinesZ(u,v);

					xe = Xe(xt,yt);
					ye = Ye(xt,yt,zt);

					x1 = xn(xe);
					y1 = ym(ye);

					LineTo(hdc,x1,y1);
				}
			}





//  ()      

					xt = splinesX(ut[0],vt[0]);
					yt = splinesY(ut[0],vt[0]);
					zt = splinesZ(ut[0],vt[0]);

					xe = Xe(xt,yt);
					ye = Ye(xt,yt,zt);

					x1 = xn(xe);
					y1 = ym(ye);

            	MoveToEx(hdc,x1,y1,0);

				for(int k=1; k<Ntext; k++)
				{

					xt = splinesX(ut[k],vt[k]);
					yt = splinesY(ut[k],vt[k]);
					zt = splinesZ(ut[k],vt[k]);

					xe = Xe(xt,yt);
					ye = Ye(xt,yt,zt);

					x1 = xn(xe);
					y1 = ym(ye);

					LineTo(hdc,x1,y1);
				}








		  DeleteObject(hPen4);

    }




//       
	HPEN hPen2 = CreatePen(PS_SOLID,1,RGB(255,255,255));
	SelectObject(hdc,hPen2);


	
	
	// 
   for(int m = 0; m <Mp; m++)
   {
		xe = Xe(Ppx[0][m],Ppy[0][m]);
		ye = Ye(Ppx[0][m],Ppy[0][m],Ppz[0][m]);
		x1=xn(xe);
		y1=ym(ye);
		for(int k=1; k<Np; k++)
		{
			xe = Xe(Ppx[k][m],Ppy[k][m]);
			ye = Ye(Ppx[k][m],Ppy[k][m],Ppz[k][m]);
			x2 = xn(xe);
			y2 = ym(ye);
			MoveToEx(hdc,x1,y1,0);
			LineTo(hdc,x2,y2);

			x1 = x2; y1 = y2;
		}
	}

//  
   for(int k = 0; k <Np; k++)
   {
		xe = Xe(Ppx[k][0],Ppy[k][0]);
		ye = Ye(Ppx[k][0],Ppy[k][0],Ppz[k][0]);
		x1=xn(xe);
		y1=ym(ye);
		for(int m=1; m<Mp; m++)
		{
			xe = Xe(Ppx[k][m],Ppy[k][m]);
			ye = Ye(Ppx[k][m],Ppy[k][m],Ppz[k][m]);
			x2 = xn(xe);
			y2 = ym(ye);
			MoveToEx(hdc,x1,y1,0);
			LineTo(hdc,x2,y2);

			x1 = x2; y1 = y2;
		}
	}



//   
   HPEN hPen3;
	hPen3 = CreatePen(PS_SOLID,1,RGB(160,160,160));
	SelectObject(hdc,hPen3);

	DrawBox(hwnd, hdc, angl);

//    
	SelectObject(hdc,hPenOld);
//   
	DeleteObject(hPen1);
	DeleteObject(hPen2);
	DeleteObject(hPen3);
	DeleteObject(hBrush0);
	DeleteObject(hBrush1);
	DeleteObject(hBrush2);
	DeleteObject(hrgn2);

	BitBlt(hdcWin,ne1,me2-30,ne2,me1,hdc,ne1,me2-30,SRCCOPY); //-
   //     

	SelectObject(hdc, hBitmapOld); //  
	DeleteObject(hBitmap); //  
	DeleteDC(hdc);  //    


//  
		ReleaseDC(hwnd, hdcWin);

//  
//	EndPaint(hwnd, &ps);
}





//       
void LineLButtonDown( int x, int y)
{
	Dat.ButtonDown = TRUE;
	Dat.Drawing = FALSE;

   anglOld.fi = angl.fi;
	anglOld.teta = angl.teta;
	corOld.x = x;
	corOld.y = y;

}

//       
//        
void LineMouseMove(HWND hwnd,int x, int y)
{
	if(Dat.ButtonDown)
	{
		Dat.Drawing = TRUE;

//  
		HDC hdc = GetDC(hwnd);

//      
		HRGN hrgn1 = CreateRectRgn(ne1,me2-30,ne2,me2-1);

//    
		HBRUSH hBrush0 = CreateSolidBrush(RGB(0xA6,0xCA,0xF0));
   	FillRgn(hdc,hrgn1,hBrush0);

//    
	HBRUSH hBrush1 = CreateSolidBrush(RGB(0xFF,0xFF,0xC0));
	FrameRgn(hdc,hrgn1,hBrush1,2,2);


//      hrgn1
	   char ss[10];
		SetBkColor(hdc,RGB(0xA6,0xCA,0xF0));
		SetTextColor(hdc,RGB(0,0,0x80));
   	sprintf(ss,"fi = %4.0lf",angl.fi);
   	TextOut(hdc,(ne1+ne2)/2-80,me2-25,ss,9);
   	sprintf(ss,"teta = %4.0lf",angl.teta);
   	TextOut(hdc,(ne1+ne2)/2+20,me2-25,ss,11);

//  hrgn1
		DeleteObject(hrgn1);

//   
		DeleteObject(hBrush0);
		DeleteObject(hBrush1);

//  
		ReleaseDC(hwnd, hdc);


		angl.fi += corOld.x-x;
		angl.teta += corOld.y-y;
		corOld.x = x; corOld.y = y;

		anglOld.fi   = angl.fi;
		anglOld.teta   = angl.teta;


	}
}


//       
void DrawBox(HWND hwnd, HDC hdc, ANGLS an)
{
	sf=sin(3.14159*an.fi/180);
	cf=cos(3.14159*an.fi/180);
	st=sin(3.14159*an.teta/180);
	ct=cos(3.14159*an.teta/180);

   double xe, ye;
	int x1,y1,x2,y2;
	double xt1,yt1,zt1,xt2,yt2,zt2;
   int j;

	for(int i=0; i<4; i++)
	{
		j = i + 1;
		if(j==4)
			j = 0;
		xt1 = Point[i].x; yt1 = Point[i].y; zt1 = Point[i].z;
		xt2 = Point[j].x; yt2 = Point[j].y; zt2 = Point[j].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	for( i=4; i<8; i++)
	{
		j = i + 1;
		if(j==8)
			j = 4;
		xt1 = Point[i].x; yt1 = Point[i].y; zt1 = Point[i].z;
		xt2 = Point[j].x; yt2 = Point[j].y; zt2 = Point[j].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	for( i=0; i<4; i++)
	{
		xt1 =   Point[i].x; yt1 =   Point[i].y; zt1 =   Point[i].z;
		xt2 = Point[i+4].x; yt2 = Point[i+4].y; zt2 = Point[i+4].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}

	for( i=0; i<2; i++)
	{
		xt1 =   Point[i].x; yt1 =   Point[i].y; zt1 =   Point[i].z;
		xt2 = Point[i+2].x; yt2 = Point[i+2].y; zt2 = Point[i+2].z;

		xe=Xe(xt1,yt1);
		ye=Ye(xt1,yt1,zt1);
		x1=xn(xe);
		y1=ym(ye);

		xe=Xe(xt2,yt2);
		ye=Ye(xt2,yt2,zt2);
		x2=xn(xe);
		y2=ym(ye);

		MoveToEx(hdc,x1,y1,0);
		LineTo(hdc,x2,y2);
	}
}



//       
void LineLButtonUp()
{
	if(Dat.ButtonDown && Dat.Drawing)
	{
		Dat.Drawing = FALSE;
	}
	Dat.ButtonDown = FALSE;
}

