

#define STRICT
#include <windows.h>
#include <windowsx.h>
#include <gl\gl.h>
#include <gl\glu.h>

//    
char const szClassName[] = "OpenGL";
// 
char const szWindowTitle[] = "Korneev V.  Graphics by OpenGL";


// 
BOOL RegisterApp(HINSTANCE);
HWND CreateApp(HINSTANCE, int);
LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);
void DestroyOpenGL();
void DrawOpenGL(HWND);


// 
int PASCAL WinMain(HINSTANCE hInstance,
				HINSTANCE hPrevInstance,
				LPSTR     lpszCmdParam,
				int       nCmdShow)
{
	MSG msg;     //    

//    
	if(!RegisterApp(hInstance))
		return FALSE;

//   
	if(!CreateApp(hInstance,nCmdShow))
		return FALSE;

//  
	while(GetMessage(&msg,NULL,0,0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}

//    
BOOL RegisterApp(HINSTANCE hInstance)
{
	WNDCLASS wc;  //      

	wc.style         = CS_HREDRAW | CS_VREDRAW; // 
	wc.lpfnWndProc   = WndProc;                 //  
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;               // 
	wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
	wc.hCursor		  = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = GetStockBrush(LTGRAY_BRUSH);
	wc.lpszMenuName  = "GLMENU";         //   
	wc.lpszClassName = szClassName;      //    

	return RegisterClass(&wc);
}



//   
HWND CreateApp(HINSTANCE hInstance, int nCmdShow)
{
	HWND hwnd;   //   

	hwnd = CreateWindow(szClassName,		//  
						szWindowTitle,		// 
						WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN
						| WS_CLIPSIBLINGS,	// 
						CW_USEDEFAULT,		//   
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						CW_USEDEFAULT,
						NULL,
						NULL,
						hInstance,
						NULL);

	if(hwnd == NULL)
		return hwnd;

// 
	ShowWindow(hwnd,nCmdShow);
// 
	UpdateWindow(hwnd);

	return hwnd;
}

// ,  
LRESULT CALLBACK  WndProc(HWND hwnd, UINT msg,
							WPARAM wParam, LPARAM lParam)
{

	switch(msg)
	{
		case WM_COMMAND:  //    
			switch(wParam)
			{
				case 200:
					InvalidateRect(hwnd,NULL,TRUE); // 
					break;
				case 202:
					DrawOpenGL(hwnd);   //  
					break;
				case 201:
					DestroyWindow(hwnd); //  
					break;
			}
			break;  

		case WM_DESTROY:
			DestroyOpenGL();
			break;
		
		default:
			return DefWindowProc(hwnd,msg,wParam,lParam);
	}

	return 0L;
}

//  
void DestroyOpenGL()
{
	PostQuitMessage(0);   //  
}


//  
void DrawOpenGL(HWND hwnd)
{
	HDC hdc = GetDC(hwnd); //  

//   
	PIXELFORMATDESCRIPTOR pfd;

//    pfd
	memset(&pfd, 0, sizeof(PIXELFORMATDESCRIPTOR));

//   
	pfd.nSize      = sizeof(PIXELFORMATDESCRIPTOR);
	pfd.nVersion   = 1;
	pfd.dwFlags    = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL;
	pfd.iPixelType = PFD_TYPE_RGBA;
	pfd.cColorBits = 24;
	pfd.cDepthBits = 32;

//    
	int iPixelFormat = ChoosePixelFormat(hdc, &pfd);
//      
	SetPixelFormat(hdc, iPixelFormat, &pfd);

//   OpenGL
	HGLRC hglrc = wglCreateContext(hdc);
//    OpenGL
	wglMakeCurrent(hdc, hglrc);




   glClearColor(1.0f,1.0f,1.0f, 1.0f);
   glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
   glClearDepth(1.0);
   glEnable(GL_DEPTH_TEST);





   RECT rc;

//     rc
   GetClientRect(hwnd, &rc);
//   
// gluPerspective(f,a,zN,zF) f- , a- 
//, zN-     
//                    zF-     
   gluPerspective(50, (double)rc.right/rc.bottom, 1, 40);
//     
   glTranslatef(0, 0, -10);
//     
   glRotatef(27, 1, 0, 0);
   glRotatef(-19, 0, 1, 0);

//  
   glColor3f(1, 1, 0);
   glBegin(GL_TRIANGLES);
   glVertex3f(0, 4, 0);
   glVertex3f(-2.0f, 0.7f, 2.0f);
   glVertex3f(2.0f, 0.7f, 2.0f);
   glEnd();

// 
   glColor3f(0.8f, 0.8f, 0);
   glBegin(GL_TRIANGLES);
   glVertex3f(0, 4, 0);
   glVertex3f(-2.0f, 0.7f, -2.0f);
   glVertex3f(2.0f, 0.7f, -2.0f);
   glEnd();

// 
   glColor3f(0.5, 0.5, 0);
   glBegin(GL_TRIANGLES);
   glVertex3f(0, 4, 0);
   glVertex3f(2.0f, 0.7f, 2.0f);
   glVertex3f(2.0f, 0.7f, -2.0f);
   glEnd();


// 
   glBegin(GL_TRIANGLES);
   glVertex3f(0, 4, 0);
   glVertex3f(-2.0f, 0.7f, 2.0f);
   glVertex3f(-2.0f, 0.7f, -2.0f);
   glEnd();


// 
   glColor3f(0.8f, 0.8f, 0.0f);
   glBegin(GL_QUADS);
   glVertex3f(-2.0f, 0.7f, -2.0f);
   glVertex3f(2.0f, 0.7f, -2.0f);
   glVertex3f(2.0f, 0.7f, 2.0f);
   glVertex3f(-2.0f, 0.7f, 2.0f);
   glEnd();




// 
   for(int j=-5; j <5; j++)
   	for(int i=-5; i<5; i++)
      {
      	if((abs(i+j)%2) == 0)
			   glColor3f(1, 0, 0);
         else
			   glColor3f(0.8f, 0.8f, 0.8f);

		   glBegin(GL_QUADS);
   		glVertex3f((float)i, 0, (float)j);
   		glVertex3f((float)(i+1), 0, (float)j);
   		glVertex3f((float)(i+1), 0, (float)(j+1));
   		glVertex3f((float)i, 0, (float)(j+1));
   		glEnd();

      }





//     
	wglMakeCurrent(NULL, NULL);
//   OpenGL
	wglDeleteContext(hglrc);

//  
	ReleaseDC(hwnd,hdc);
}





